"use strict";

var e = require("../language/kinds.js");

var i = require("../type/directives.js");

var r = require("../type/definition.js");

var t = require("../utilities/typeFromAST.js");

var n = require("./values.js");

function shouldIncludeNode(e, r) {
  var t = n.getDirectiveValues(i.GraphQLSkipDirective, r, e);
  if (!0 === (null == t ? void 0 : t.if)) {
    return !1;
  }
  var a = n.getDirectiveValues(i.GraphQLIncludeDirective, r, e);
  if (!1 === (null == a ? void 0 : a.if)) {
    return !1;
  }
  return !0;
}

function doesFragmentConditionMatch(e, i, n) {
  var a = i.typeCondition;
  if (!a) {
    return !0;
  }
  var s = t.typeFromAST(e, a);
  if (s === n) {
    return !0;
  }
  if (r.isAbstractType(s)) {
    return e.isSubType(s, n);
  }
  return !1;
}

exports.collectFields = function collectFields(i, r, t, n, a, s, u) {
  for (var o = 0, l = a.selections; o < l.length; o += 1) {
    var c = l[o];
    switch (c.kind) {
     case e.Kind.FIELD:
      if (!shouldIncludeNode(t, c)) {
        continue;
      }
      var d = (p = c).alias ? p.alias.value : p.name.value;
      var v = s.get(d);
      if (void 0 !== v) {
        v.push(c);
      } else {
        s.set(d, [ c ]);
      }
      break;

     case e.Kind.INLINE_FRAGMENT:
      if (!shouldIncludeNode(t, c) || !doesFragmentConditionMatch(i, c, n)) {
        continue;
      }
      collectFields(i, r, t, n, c.selectionSet, s, u);
      break;

     case e.Kind.FRAGMENT_SPREAD:
      var f = c.name.value;
      if (u.has(f) || !shouldIncludeNode(t, c)) {
        continue;
      }
      u.add(f);
      var h = r[f];
      if (!h || !doesFragmentConditionMatch(i, h, n)) {
        continue;
      }
      collectFields(i, r, t, n, h.selectionSet, s, u);
    }
  }
  var p;
  return s;
};
