import { Kind as e } from "../language/kinds.mjs";

import { GraphQLSkipDirective as i, GraphQLIncludeDirective as t } from "../type/directives.mjs";

import { isAbstractType as n } from "../type/definition.mjs";

import { typeFromAST as o } from "../utilities/typeFromAST.mjs";

import { getDirectiveValues as r } from "./values.mjs";

function collectFields(i, t, n, o, r, l, a) {
  for (var s = 0, u = r.selections; s < u.length; s += 1) {
    var d = u[s];
    switch (d.kind) {
     case e.FIELD:
      if (!shouldIncludeNode(n, d)) {
        continue;
      }
      var c = (p = d).alias ? p.alias.value : p.name.value;
      var f = l.get(c);
      if (void 0 !== f) {
        f.push(d);
      } else {
        l.set(c, [ d ]);
      }
      break;

     case e.INLINE_FRAGMENT:
      if (!shouldIncludeNode(n, d) || !doesFragmentConditionMatch(i, d, o)) {
        continue;
      }
      collectFields(i, t, n, o, d.selectionSet, l, a);
      break;

     case e.FRAGMENT_SPREAD:
      var m = d.name.value;
      if (a.has(m) || !shouldIncludeNode(n, d)) {
        continue;
      }
      a.add(m);
      var v = t[m];
      if (!v || !doesFragmentConditionMatch(i, v, o)) {
        continue;
      }
      collectFields(i, t, n, o, v.selectionSet, l, a);
    }
  }
  var p;
  return l;
}

function shouldIncludeNode(e, n) {
  var o = r(i, n, e);
  if (!0 === (null == o ? void 0 : o.if)) {
    return !1;
  }
  var l = r(t, n, e);
  if (!1 === (null == l ? void 0 : l.if)) {
    return !1;
  }
  return !0;
}

function doesFragmentConditionMatch(e, i, t) {
  var r = i.typeCondition;
  if (!r) {
    return !0;
  }
  var l = o(e, r);
  if (l === t) {
    return !0;
  }
  if (n(l)) {
    return e.isSubType(l, t);
  }
  return !1;
}

export { collectFields };
