"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/inspect.js");

var r = require("../jsutils/memoize3.js");

var t = require("../jsutils/invariant.js");

var i = require("../jsutils/isPromise.js");

var n = require("../jsutils/isObjectLike.js");

var a = require("../jsutils/promiseReduce.js");

var o = require("../jsutils/promiseForObject.js");

var u = require("../jsutils/Path.js");

var l = require("../jsutils/isIterableObject.js");

var s = require("../error/GraphQLError.js");

var c = require("../error/locatedError.js");

var p = require("../language/kinds.js");

var f = require("../type/validate.js");

var v = require("../type/introspection.js");

var d = require("../type/definition.js");

var m = require("../utilities/getOperationRootType.js");

var h = require("./values.js");

var y = require("./collectFields.js");

function execute(e) {
  var r = e.schema;
  var t = e.document;
  var n = e.rootValue;
  var o = e.contextValue;
  var l = e.variableValues;
  var s = e.operationName;
  var c = e.fieldResolver;
  var p = e.typeResolver;
  assertValidExecutionArguments(r);
  var f = buildExecutionContext(r, t, n, o, l, s, c, p);
  if (!("schema" in f)) {
    return {
      errors: f
    };
  }
  var v = function executeOperation(e, r, t) {
    var n = m.getOperationRootType(e.schema, r);
    var o = y.collectFields(e.schema, e.fragments, e.variableValues, n, r.selectionSet, new Map, new Set);
    var l = void 0;
    try {
      var s = "mutation" === r.operation ? function executeFieldsSerially(e, r, t, n, o) {
        return a.promiseReduce(o.entries(), (function(a, o) {
          var l = o[0];
          var s = o[1];
          var c = u.addPath(n, l, r.name);
          var p = executeField(e, r, t, s, c);
          if (void 0 === p) {
            return a;
          }
          if (i.isPromise(p)) {
            return p.then((function(e) {
              a[l] = e;
              return a;
            }));
          }
          a[l] = p;
          return a;
        }), Object.create(null));
      }(e, n, t, l, o) : executeFields(e, n, t, l, o);
      if (i.isPromise(s)) {
        return s.then(void 0, (function(r) {
          e.errors.push(r);
          return Promise.resolve(null);
        }));
      }
      return s;
    } catch (r) {
      e.errors.push(r);
      return null;
    }
  }(f, f.operation, n);
  return buildResponse(f, v);
}

function buildResponse(e, r) {
  if (i.isPromise(r)) {
    return r.then((function(r) {
      return buildResponse(e, r);
    }));
  }
  return 0 === e.errors.length ? {
    data: r
  } : {
    errors: e.errors,
    data: r
  };
}

function assertValidExecutionArguments(e, r, t) {
  f.assertValidSchema(e);
}

function buildExecutionContext(e, r, t, i, n, a, o, u) {
  var l, c;
  var f;
  var v = Object.create(null);
  for (var d = 0, m = r.definitions; d < m.length; d += 1) {
    var y = m[d];
    switch (y.kind) {
     case p.Kind.OPERATION_DEFINITION:
      if (null == a) {
        if (void 0 !== f) {
          return [ new s.GraphQLError("Must provide operation name if query contains multiple operations.") ];
        }
        f = y;
      } else if ((null === (l = y.name) || void 0 === l ? void 0 : l.value) === a) {
        f = y;
      }
      break;

     case p.Kind.FRAGMENT_DEFINITION:
      v[y.name.value] = y;
    }
  }
  if (!f) {
    if (null != a) {
      return [ new s.GraphQLError('Unknown operation named "' + a + '".') ];
    }
    return [ new s.GraphQLError("Must provide an operation.") ];
  }
  var b = null !== (c = f.variableDefinitions) && void 0 !== c ? c : [];
  var j = h.getVariableValues(e, b, null != n ? n : {}, {
    maxErrors: 50
  });
  if (j.errors) {
    return j.errors;
  }
  return {
    schema: e,
    fragments: v,
    rootValue: t,
    contextValue: i,
    operation: f,
    variableValues: j.coerced,
    fieldResolver: null != o ? o : defaultFieldResolver,
    typeResolver: null != u ? u : defaultTypeResolver,
    errors: []
  };
}

function executeFields(e, r, t, n, a) {
  var l = Object.create(null);
  var s = !1;
  for (var c = 0, p = a.entries(); c < p.length; c += 1) {
    var f = p[c];
    var v = f[0];
    var d = executeField(e, r, t, f[1], u.addPath(n, v, r.name));
    if (void 0 !== d) {
      l[v] = d;
      if (i.isPromise(d)) {
        s = !0;
      }
    }
  }
  if (!s) {
    return l;
  }
  return o.promiseForObject(l);
}

function executeField(e, r, t, n, a) {
  var o;
  var l = getFieldDef(e.schema, r, n[0]);
  if (!l) {
    return;
  }
  var s = l.type;
  var p = null !== (o = l.resolve) && void 0 !== o ? o : e.fieldResolver;
  var f = buildResolveInfo(e, l, n, r, a);
  try {
    var v = p(t, h.getArgumentValues(l, n[0], e.variableValues), e.contextValue, f);
    var d;
    if (i.isPromise(v)) {
      d = v.then((function(r) {
        return completeValue(e, s, n, f, a, r);
      }));
    } else {
      d = completeValue(e, s, n, f, a, v);
    }
    if (i.isPromise(d)) {
      return d.then(void 0, (function(r) {
        return handleFieldError(c.locatedError(r, n, u.pathToArray(a)), s, e);
      }));
    }
    return d;
  } catch (r) {
    return handleFieldError(c.locatedError(r, n, u.pathToArray(a)), s, e);
  }
}

function buildResolveInfo(e, r, t, i, n) {
  return {
    fieldName: r.name,
    fieldNodes: t,
    returnType: r.type,
    parentType: i,
    path: n,
    schema: e.schema,
    fragments: e.fragments,
    rootValue: e.rootValue,
    operation: e.operation,
    variableValues: e.variableValues
  };
}

function handleFieldError(e, r, t) {
  if (d.isNonNullType(r)) {
    throw e;
  }
  t.errors.push(e);
  return null;
}

function completeValue(r, n, a, o, p, f) {
  if (f instanceof Error) {
    throw f;
  }
  if (d.isNonNullType(n)) {
    var v = completeValue(r, n.ofType, a, o, p, f);
    if (null === v) {
      throw new Error("Cannot return null for non-nullable field " + o.parentType.name + "." + o.fieldName + ".");
    }
    return v;
  }
  if (null == f) {
    return null;
  }
  if (d.isListType(n)) {
    return function completeListValue(e, r, t, n, a, o) {
      if (!l.isIterableObject(o)) {
        throw new s.GraphQLError('Expected Iterable, but did not find one for field "' + n.parentType.name + "." + n.fieldName + '".');
      }
      var p = r.ofType;
      var f = !1;
      var v = Array.from(o, (function(r, o) {
        var l = u.addPath(a, o, void 0);
        try {
          var s;
          if (i.isPromise(r)) {
            s = r.then((function(r) {
              return completeValue(e, p, t, n, l, r);
            }));
          } else {
            s = completeValue(e, p, t, n, l, r);
          }
          if (i.isPromise(s)) {
            f = !0;
            return s.then(void 0, (function(r) {
              return handleFieldError(c.locatedError(r, t, u.pathToArray(l)), p, e);
            }));
          }
          return s;
        } catch (r) {
          return handleFieldError(c.locatedError(r, t, u.pathToArray(l)), p, e);
        }
      }));
      return f ? Promise.all(v) : v;
    }(r, n, a, o, p, f);
  }
  if (d.isLeafType(n)) {
    return function completeLeafValue(r, t) {
      var i = r.serialize(t);
      if (void 0 === i) {
        throw new Error('Expected a value of type "' + e.inspect(r) + '" but received: ' + e.inspect(t));
      }
      return i;
    }(n, f);
  }
  if (d.isAbstractType(n)) {
    return function completeAbstractValue(e, r, t, n, a, o) {
      var u;
      var l = (null !== (u = r.resolveType) && void 0 !== u ? u : e.typeResolver)(o, e.contextValue, n, r);
      if (i.isPromise(l)) {
        return l.then((function(i) {
          return completeObjectValue(e, ensureValidRuntimeType(i, e, r, t, n, o), t, n, a, o);
        }));
      }
      return completeObjectValue(e, ensureValidRuntimeType(l, e, r, t, n, o), t, n, a, o);
    }(r, n, a, o, p, f);
  }
  if (d.isObjectType(n)) {
    return completeObjectValue(r, n, a, o, p, f);
  }
  t.invariant(!1);
}

function ensureValidRuntimeType(r, t, i, n, a, o) {
  if (null == r) {
    throw new s.GraphQLError('Abstract type "' + i.name + '" must resolve to an Object type at runtime for field "' + a.parentType.name + "." + a.fieldName + '". Either the "' + i.name + '" type should provide a "resolveType" function or each possible type should provide an "isTypeOf" function.', n);
  }
  if (d.isObjectType(r)) {
    throw new s.GraphQLError("Support for returning GraphQLObjectType from resolveType was removed in graphql-js@16.0.0 please return type name instead.");
  }
  if ("string" != typeof r) {
    throw new s.GraphQLError('Abstract type "' + i.name + '" must resolve to an Object type at runtime for field "' + a.parentType.name + "." + a.fieldName + '" with value ' + e.inspect(o) + ', received "' + e.inspect(r) + '".');
  }
  var u = t.schema.getType(r);
  if (null == u) {
    throw new s.GraphQLError('Abstract type "' + i.name + '" was resolved to a type "' + r + '" that does not exist inside the schema.', n);
  }
  if (!d.isObjectType(u)) {
    throw new s.GraphQLError('Abstract type "' + i.name + '" was resolved to a non-object type "' + r + '".', n);
  }
  if (!t.schema.isSubType(i, u)) {
    throw new s.GraphQLError('Runtime Object type "' + u.name + '" is not a possible type for "' + i.name + '".', n);
  }
  return u;
}

function completeObjectValue(e, r, t, n, a, o) {
  var u = b(e, r, t);
  if (r.isTypeOf) {
    var l = r.isTypeOf(o, e.contextValue, n);
    if (i.isPromise(l)) {
      return l.then((function(i) {
        if (!i) {
          throw invalidReturnTypeError(r, o, t);
        }
        return executeFields(e, r, o, a, u);
      }));
    }
    if (!l) {
      throw invalidReturnTypeError(r, o, t);
    }
  }
  return executeFields(e, r, o, a, u);
}

function invalidReturnTypeError(r, t, i) {
  return new s.GraphQLError('Expected value of type "' + r.name + '" but got: ' + e.inspect(t) + ".", i);
}

var b = r.memoize3((function _collectSubfields(e, r, t) {
  var i = new Map;
  var n = new Set;
  for (var a = 0, o = t; a < o.length; a += 1) {
    var u = o[a];
    if (u.selectionSet) {
      i = y.collectFields(e.schema, e.fragments, e.variableValues, r, u.selectionSet, i, n);
    }
  }
  return i;
}));

var defaultTypeResolver = function(e, r, t, a) {
  if (n.isObjectLike(e) && "string" == typeof e.__typename) {
    return e.__typename;
  }
  var o = t.schema.getPossibleTypes(a);
  var u = [];
  for (var l = 0; l < o.length; l++) {
    var s = o[l];
    if (s.isTypeOf) {
      var c = s.isTypeOf(e, r, t);
      if (i.isPromise(c)) {
        u[l] = c;
      } else if (c) {
        return s.name;
      }
    }
  }
  if (u.length) {
    return Promise.all(u).then((function(e) {
      for (var r = 0; r < e.length; r++) {
        if (e[r]) {
          return o[r].name;
        }
      }
    }));
  }
};

var defaultFieldResolver = function(e, r, t, i) {
  if (n.isObjectLike(e) || "function" == typeof e) {
    var a = e[i.fieldName];
    if ("function" == typeof a) {
      return e[i.fieldName](r, t, i);
    }
    return a;
  }
};

function getFieldDef(e, r, t) {
  var i = t.name.value;
  if (i === v.SchemaMetaFieldDef.name && e.getQueryType() === r) {
    return v.SchemaMetaFieldDef;
  } else if (i === v.TypeMetaFieldDef.name && e.getQueryType() === r) {
    return v.TypeMetaFieldDef;
  } else if (i === v.TypeNameMetaFieldDef.name) {
    return v.TypeNameMetaFieldDef;
  }
  return r.getFields()[i];
}

exports.assertValidExecutionArguments = assertValidExecutionArguments;

exports.buildExecutionContext = buildExecutionContext;

exports.buildResolveInfo = buildResolveInfo;

exports.defaultFieldResolver = defaultFieldResolver;

exports.defaultTypeResolver = defaultTypeResolver;

exports.execute = execute;

exports.executeSync = function executeSync(e) {
  var r = execute(e);
  if (i.isPromise(r)) {
    throw new Error("GraphQL execution failed to complete synchronously.");
  }
  return r;
};

exports.getFieldDef = getFieldDef;
