"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var r = require("../jsutils/keyMap.js");

var e = require("../jsutils/inspect.js");

var a = require("../jsutils/printPathArray.js");

var t = require("../error/GraphQLError.js");

var n = require("../language/kinds.js");

var i = require("../language/printer.js");

var u = require("../type/definition.js");

var l = require("../utilities/typeFromAST.js");

var o = require("../utilities/valueFromAST.js");

var s = require("../utilities/coerceInputValue.js");

function getArgumentValues(a, l, s) {
  var v;
  var p = {};
  var f = null !== (v = l.arguments) && void 0 !== v ? v : [];
  var d = r.keyMap(f, (function(r) {
    return r.name.value;
  }));
  for (var c = 0, h = a.args; c < h.length; c += 1) {
    var y = h[c];
    var g = y.name;
    var m = y.type;
    var V = d[g];
    if (!V) {
      if (void 0 !== y.defaultValue) {
        p[g] = y.defaultValue;
      } else if (u.isNonNullType(m)) {
        throw new t.GraphQLError('Argument "' + g + '" of required type "' + e.inspect(m) + '" was not provided.', l);
      }
      continue;
    }
    var w = V.value;
    var A = w.kind === n.Kind.NULL;
    if (w.kind === n.Kind.VARIABLE) {
      var b = w.name.value;
      if (null == s || !hasOwnProperty(s, b)) {
        if (void 0 !== y.defaultValue) {
          p[g] = y.defaultValue;
        } else if (u.isNonNullType(m)) {
          throw new t.GraphQLError('Argument "' + g + '" of required type "' + e.inspect(m) + '" was provided the variable "$' + b + '" which was not provided a runtime value.', w);
        }
        continue;
      }
      A = null == s[b];
    }
    if (A && u.isNonNullType(m)) {
      throw new t.GraphQLError('Argument "' + g + '" of non-null type "' + e.inspect(m) + '" must not be null.', w);
    }
    var j = o.valueFromAST(w, m, s);
    if (void 0 === j) {
      throw new t.GraphQLError('Argument "' + g + '" has invalid value ' + i.print(w) + ".", w);
    }
    p[g] = j;
  }
  return p;
}

function hasOwnProperty(r, e) {
  return Object.prototype.hasOwnProperty.call(r, e);
}

exports.getArgumentValues = getArgumentValues;

exports.getDirectiveValues = function getDirectiveValues(r, e, a) {
  var t;
  var n = null === (t = e.directives) || void 0 === t ? void 0 : t.find((function(e) {
    return e.name.value === r.name;
  }));
  if (n) {
    return getArgumentValues(r, n, a);
  }
};

exports.getVariableValues = function getVariableValues(r, n, v, p) {
  var f = [];
  var d = null == p ? void 0 : p.maxErrors;
  try {
    var c = function coerceVariableValues(r, n, v, p) {
      var f = {};
      var loop = function() {
        var n = c[d];
        var h = n.variable.name.value;
        var y = l.typeFromAST(r, n.type);
        if (!u.isInputType(y)) {
          var g = i.print(n.type);
          p(new t.GraphQLError('Variable "$' + h + '" expected value of type "' + g + '" which cannot be used as an input type.', n.type));
          return;
        }
        if (!hasOwnProperty(v, h)) {
          if (n.defaultValue) {
            f[h] = o.valueFromAST(n.defaultValue, y);
          } else if (u.isNonNullType(y)) {
            var m = e.inspect(y);
            p(new t.GraphQLError('Variable "$' + h + '" of required type "' + m + '" was not provided.', n));
          }
          return;
        }
        var V = v[h];
        if (null === V && u.isNonNullType(y)) {
          var w = e.inspect(y);
          p(new t.GraphQLError('Variable "$' + h + '" of non-null type "' + w + '" must not be null.', n));
          return;
        }
        f[h] = s.coerceInputValue(V, y, (function(r, i, u) {
          var l = 'Variable "$' + h + '" got invalid value ' + e.inspect(i);
          if (r.length > 0) {
            l += ' at "' + h + a.printPathArray(r) + '"';
          }
          p(new t.GraphQLError(l + "; " + u.message, n, void 0, void 0, void 0, u.originalError));
        }));
      };
      for (var d = 0, c = n; d < c.length; d += 1) {
        loop();
      }
      return f;
    }(r, n, v, (function(r) {
      if (null != d && f.length >= d) {
        throw new t.GraphQLError("Too many errors processing variables, error limit reached. Execution aborted.");
      }
      f.push(r);
    }));
    if (0 === f.length) {
      return {
        coerced: c
      };
    }
  } catch (r) {
    f.push(r);
  }
  return {
    errors: f
  };
};
