"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("./jsutils/isPromise.js");

var r = require("./language/parser.js");

var a = require("./validation/validate.js");

var t = require("./type/validate.js");

var o = require("./execution/execute.js");

function graphqlImpl(e) {
  var l = e.schema;
  var i = e.source;
  var s = e.rootValue;
  var u = e.contextValue;
  var n = e.variableValues;
  var v = e.operationName;
  var c = e.fieldResolver;
  var p = e.typeResolver;
  var h = t.validateSchema(l);
  if (h.length > 0) {
    return {
      errors: h
    };
  }
  var m;
  try {
    m = r.parse(i);
  } catch (e) {
    return {
      errors: [ e ]
    };
  }
  var q = a.validate(l, m);
  if (q.length > 0) {
    return {
      errors: q
    };
  }
  return o.execute({
    schema: l,
    document: m,
    rootValue: s,
    contextValue: u,
    variableValues: n,
    operationName: v,
    fieldResolver: c,
    typeResolver: p
  });
}

exports.graphql = function graphql(e) {
  return new Promise((function(r) {
    return r(graphqlImpl(e));
  }));
};

exports.graphqlSync = function graphqlSync(r) {
  var a = graphqlImpl(r);
  if (e.isPromise(a)) {
    throw new Error("GraphQL execution failed to complete synchronously.");
  }
  return a;
};
