import { isPromise as r } from "./jsutils/isPromise.mjs";

import { parse as e } from "./language/parser.mjs";

import { validate as a } from "./validation/validate.mjs";

import { validateSchema as o } from "./type/validate.mjs";

import { execute as t } from "./execution/execute.mjs";

function graphql(r) {
  return new Promise((function(e) {
    return e(graphqlImpl(r));
  }));
}

function graphqlSync(e) {
  var a = graphqlImpl(e);
  if (r(a)) {
    throw new Error("GraphQL execution failed to complete synchronously.");
  }
  return a;
}

function graphqlImpl(r) {
  var l = r.schema;
  var n = r.source;
  var i = r.rootValue;
  var m = r.contextValue;
  var s = r.variableValues;
  var u = r.operationName;
  var p = r.fieldResolver;
  var v = r.typeResolver;
  var c = o(l);
  if (c.length > 0) {
    return {
      errors: c
    };
  }
  var f;
  try {
    f = e(n);
  } catch (r) {
    return {
      errors: [ r ]
    };
  }
  var h = a(l, f);
  if (h.length > 0) {
    return {
      errors: h
    };
  }
  return t({
    schema: l,
    document: f,
    rootValue: i,
    contextValue: m,
    variableValues: s,
    operationName: u,
    fieldResolver: p,
    typeResolver: v
  });
}

export { graphql, graphqlSync };
