"use strict";

var r = require("./naturalCompare.js");

var t = function LexicalDistance(r) {
  this._input = r;
  this._inputLowerCase = r.toLowerCase();
  this._inputArray = stringToArray(this._inputLowerCase);
  this._rows = [ new Array(r.length + 1).fill(0), new Array(r.length + 1).fill(0), new Array(r.length + 1).fill(0) ];
};

t.prototype.measure = function measure(r, t) {
  if (this._input === r) {
    return 0;
  }
  var a = r.toLowerCase();
  if (this._inputLowerCase === a) {
    return 1;
  }
  var e = stringToArray(a);
  var n = this._inputArray;
  if (e.length < n.length) {
    var i = e;
    e = n;
    n = i;
  }
  var o = e.length;
  var s = n.length;
  if (o - s > t) {
    return;
  }
  var u = this._rows;
  for (var v = 0; v <= s; v++) {
    u[0][v] = v;
  }
  for (var h = 1; h <= o; h++) {
    var f = u[(h - 1) % 3];
    var l = u[h % 3];
    var g = l[0] = h;
    for (var c = 1; c <= s; c++) {
      var p = Math.min(f[c] + 1, l[c - 1] + 1, f[c - 1] + (e[h - 1] === n[c - 1] ? 0 : 1));
      if (h > 1 && c > 1 && e[h - 1] === n[c - 2] && e[h - 2] === n[c - 1]) {
        p = Math.min(p, u[(h - 2) % 3][c - 2] + 1);
      }
      if (p < g) {
        g = p;
      }
      l[c] = p;
    }
    if (g > t) {
      return;
    }
  }
  var w = u[o % 3][s];
  return w <= t ? w : void 0;
};

function stringToArray(r) {
  var t = r.length;
  var a = new Array(t);
  for (var e = 0; e < t; ++e) {
    a[e] = r.charCodeAt(e);
  }
  return a;
}

exports.suggestionList = function suggestionList(a, e) {
  var n = Object.create(null);
  var i = new t(a);
  var o = Math.floor(.4 * a.length) + 1;
  for (var s = 0, u = e; s < u.length; s += 1) {
    var v = u[s];
    var h = i.measure(v, o);
    if (void 0 !== h) {
      n[v] = h;
    }
  }
  return Object.keys(n).sort((function(t, a) {
    var e = n[t] - n[a];
    return 0 !== e ? e : r.naturalCompare(t, a);
  }));
};
