"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var i = require("./kinds.js");

function isExecutableDefinitionNode(n) {
  return n.kind === i.Kind.OPERATION_DEFINITION || n.kind === i.Kind.FRAGMENT_DEFINITION;
}

function isTypeSystemDefinitionNode(n) {
  return n.kind === i.Kind.SCHEMA_DEFINITION || isTypeDefinitionNode(n) || n.kind === i.Kind.DIRECTIVE_DEFINITION;
}

function isTypeDefinitionNode(n) {
  return n.kind === i.Kind.SCALAR_TYPE_DEFINITION || n.kind === i.Kind.OBJECT_TYPE_DEFINITION || n.kind === i.Kind.INTERFACE_TYPE_DEFINITION || n.kind === i.Kind.UNION_TYPE_DEFINITION || n.kind === i.Kind.ENUM_TYPE_DEFINITION || n.kind === i.Kind.INPUT_OBJECT_TYPE_DEFINITION;
}

function isTypeSystemExtensionNode(n) {
  return n.kind === i.Kind.SCHEMA_EXTENSION || isTypeExtensionNode(n);
}

function isTypeExtensionNode(n) {
  return n.kind === i.Kind.SCALAR_TYPE_EXTENSION || n.kind === i.Kind.OBJECT_TYPE_EXTENSION || n.kind === i.Kind.INTERFACE_TYPE_EXTENSION || n.kind === i.Kind.UNION_TYPE_EXTENSION || n.kind === i.Kind.ENUM_TYPE_EXTENSION || n.kind === i.Kind.INPUT_OBJECT_TYPE_EXTENSION;
}

exports.isDefinitionNode = function isDefinitionNode(i) {
  return isExecutableDefinitionNode(i) || isTypeSystemDefinitionNode(i) || isTypeSystemExtensionNode(i);
};

exports.isExecutableDefinitionNode = isExecutableDefinitionNode;

exports.isSelectionNode = function isSelectionNode(n) {
  return n.kind === i.Kind.FIELD || n.kind === i.Kind.FRAGMENT_SPREAD || n.kind === i.Kind.INLINE_FRAGMENT;
};

exports.isTypeDefinitionNode = isTypeDefinitionNode;

exports.isTypeExtensionNode = isTypeExtensionNode;

exports.isTypeNode = function isTypeNode(n) {
  return n.kind === i.Kind.NAMED_TYPE || n.kind === i.Kind.LIST_TYPE || n.kind === i.Kind.NON_NULL_TYPE;
};

exports.isTypeSystemDefinitionNode = isTypeSystemDefinitionNode;

exports.isTypeSystemExtensionNode = isTypeSystemExtensionNode;

exports.isValueNode = function isValueNode(n) {
  return n.kind === i.Kind.VARIABLE || n.kind === i.Kind.INT || n.kind === i.Kind.FLOAT || n.kind === i.Kind.STRING || n.kind === i.Kind.BOOLEAN || n.kind === i.Kind.NULL || n.kind === i.Kind.ENUM || n.kind === i.Kind.LIST || n.kind === i.Kind.OBJECT;
};
