import { Kind as i } from "./kinds.mjs";

function isDefinitionNode(i) {
  return isExecutableDefinitionNode(i) || isTypeSystemDefinitionNode(i) || isTypeSystemExtensionNode(i);
}

function isExecutableDefinitionNode(n) {
  return n.kind === i.OPERATION_DEFINITION || n.kind === i.FRAGMENT_DEFINITION;
}

function isSelectionNode(n) {
  return n.kind === i.FIELD || n.kind === i.FRAGMENT_SPREAD || n.kind === i.INLINE_FRAGMENT;
}

function isValueNode(n) {
  return n.kind === i.VARIABLE || n.kind === i.INT || n.kind === i.FLOAT || n.kind === i.STRING || n.kind === i.BOOLEAN || n.kind === i.NULL || n.kind === i.ENUM || n.kind === i.LIST || n.kind === i.OBJECT;
}

function isTypeNode(n) {
  return n.kind === i.NAMED_TYPE || n.kind === i.LIST_TYPE || n.kind === i.NON_NULL_TYPE;
}

function isTypeSystemDefinitionNode(n) {
  return n.kind === i.SCHEMA_DEFINITION || isTypeDefinitionNode(n) || n.kind === i.DIRECTIVE_DEFINITION;
}

function isTypeDefinitionNode(n) {
  return n.kind === i.SCALAR_TYPE_DEFINITION || n.kind === i.OBJECT_TYPE_DEFINITION || n.kind === i.INTERFACE_TYPE_DEFINITION || n.kind === i.UNION_TYPE_DEFINITION || n.kind === i.ENUM_TYPE_DEFINITION || n.kind === i.INPUT_OBJECT_TYPE_DEFINITION;
}

function isTypeSystemExtensionNode(n) {
  return n.kind === i.SCHEMA_EXTENSION || isTypeExtensionNode(n);
}

function isTypeExtensionNode(n) {
  return n.kind === i.SCALAR_TYPE_EXTENSION || n.kind === i.OBJECT_TYPE_EXTENSION || n.kind === i.INTERFACE_TYPE_EXTENSION || n.kind === i.UNION_TYPE_EXTENSION || n.kind === i.ENUM_TYPE_EXTENSION || n.kind === i.INPUT_OBJECT_TYPE_EXTENSION;
}

export { isDefinitionNode, isExecutableDefinitionNode, isSelectionNode, isTypeDefinitionNode, isTypeExtensionNode, isTypeNode, isTypeSystemDefinitionNode, isTypeSystemExtensionNode, isValueNode };
