"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("./blockString.js");

var r = require("./printString.js");

var join = function(e, r) {
  return e && e.filter((function(e) {
    return e;
  })).join(r || "") || "";
};

var block = function(e) {
  return wrap("{\n  ", join(e, "\n").replace(/\n/g, "\n  "), "\n}");
};

var wrap = function(e, r, n) {
  return r ? e + r + (n || "") : "";
};

exports.print = function print(n) {
  if (Array.isArray(n)) {
    return n.map(print);
  } else if (null == n || "object" != typeof n) {
    return n ? "" + n : "";
  }
  switch (n.kind) {
   case "OperationDefinition":
    var t = join([ n.operation, print(n.name) + wrap("(", join(print(n.variableDefinitions), ", "), ")"), join(print(n.directives), " ") ], " ");
    return ("query" === t ? "" : t + " ") + print(n.selectionSet);

   case "VariableDefinition":
    return print(n.variable) + ": " + print(n.type) + wrap(" = ", print(n.defaultValue)) + wrap(" ", join(print(n.directives), " "));

   case "Field":
    var i = wrap("", print(n.alias), ": ") + print(n.name);
    if ("optional" === n.required) {
      i += "?";
    } else if ("required" === n.required) {
      i += "!";
    }
    return join([ i + wrap("(", join(print(n.arguments), ", "), ")"), join(print(n.directives), " "), print(n.selectionSet) ], " ");

   case "StringValue":
    return n.isBlockString ? e.printBlockString(n.value) : r.printString(n.value);

   case "BooleanValue":
    return n.value ? "true" : "false";

   case "NullValue":
    return "null";

   case "IntValue":
   case "FloatValue":
   case "EnumValue":
   case "Name":
    return n.value;

   case "ListValue":
    return "[" + join(print(n.values), ", ") + "]";

   case "ObjectValue":
    return "{" + join(print(n.fields), ", ") + "}";

   case "ObjectField":
    return n.name.value + ": " + print(n.value);

   case "Variable":
    return "$" + n.name.value;

   case "Document":
    return join(print(n.definitions), "\n\n") + "\n";

   case "SelectionSet":
    return block(print(n.selections));

   case "Argument":
    return n.name.value + ": " + print(n.value);

   case "FragmentSpread":
    return "..." + print(n.name) + wrap(" ", join(print(n.directives), " "));

   case "InlineFragment":
    return join([ "...", wrap("on ", print(n.typeCondition)), join(print(n.directives), " "), print(n.selectionSet) ], " ");

   case "FragmentDefinition":
    return "fragment " + n.name.value + wrap("(", join(print(n.variableDefinitions), ", "), ")") + " on " + print(n.typeCondition) + " " + wrap("", join(print(n.directives), " "), " ") + print(n.selectionSet);

   case "Directive":
    return "@" + n.name.value + wrap("(", join(print(n.arguments), ", "), ")");

   case "NamedType":
    return n.name.value;

   case "ListType":
    return "[" + print(n.type) + "]";

   case "NonNullType":
    return print(n.type) + "!";

   default:
    return "";
  }
};
