"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/inspect.js");

var r = require("../jsutils/isAsyncIterable.js");

var a = require("../jsutils/Path.js");

var t = require("../error/GraphQLError.js");

var i = require("../error/locatedError.js");

var o = require("../execution/collectFields.js");

var s = require("../execution/values.js");

var n = require("../execution/execute.js");

var u = require("../utilities/getOperationRootType.js");

var c = require("./mapAsyncIterator.js");

async function createSourceEventStream(c, v, l, d, p, f, b) {
  n.assertValidExecutionArguments(c);
  try {
    var m = n.buildExecutionContext(c, v, l, d, p, f, b);
    if (!("schema" in m)) {
      return {
        errors: m
      };
    }
    var h = await async function executeSubscription(e) {
      var r = e.schema;
      var c = e.fragments;
      var v = e.operation;
      var l = e.variableValues;
      var d = e.rootValue;
      var p = u.getOperationRootType(r, v);
      var f = o.collectFields(r, c, l, p, v.selectionSet, new Map, new Set);
      var b = [].concat(f.entries())[0];
      var m = b[0];
      var h = b[1];
      var x = n.getFieldDef(r, p, h[0]);
      if (!x) {
        throw new t.GraphQLError('The subscription field "' + h[0].name.value + '" is not defined.', h);
      }
      var y = a.addPath(void 0, m, p.name);
      var j = n.buildResolveInfo(e, x, h, p, y);
      try {
        var E;
        var w = s.getArgumentValues(x, h[0], l);
        var S = e.contextValue;
        var V = null !== (E = x.subscribe) && void 0 !== E ? E : e.fieldResolver;
        var q = await V(d, w, S, j);
        if (q instanceof Error) {
          throw q;
        }
        return q;
      } catch (e) {
        throw i.locatedError(e, h, a.pathToArray(y));
      }
    }(m);
    if (!r.isAsyncIterable(h)) {
      throw new Error("Subscription field must return Async Iterable. Received: " + e.inspect(h) + ".");
    }
    return h;
  } catch (e) {
    if (e instanceof t.GraphQLError) {
      return {
        errors: [ e ]
      };
    }
    throw e;
  }
}

exports.createSourceEventStream = createSourceEventStream;

exports.subscribe = async function subscribe(e) {
  var a = e.schema;
  var t = e.document;
  var i = e.rootValue;
  var o = e.contextValue;
  var s = e.variableValues;
  var u = e.operationName;
  var v = e.fieldResolver;
  var l = e.subscribeFieldResolver;
  var d = await createSourceEventStream(a, t, i, o, s, u, l);
  if (!r.isAsyncIterable(d)) {
    return d;
  }
  return c.mapAsyncIterator(d, (function(e) {
    return n.execute({
      schema: a,
      document: t,
      rootValue: e,
      contextValue: o,
      variableValues: s,
      operationName: u,
      fieldResolver: v
    });
  }));
};
