import { inspect as r } from "../jsutils/inspect.mjs";

import { isAsyncIterable as e } from "../jsutils/isAsyncIterable.mjs";

import { pathToArray as t, addPath as a } from "../jsutils/Path.mjs";

import { GraphQLError as o } from "../error/GraphQLError.mjs";

import { locatedError as i } from "../error/locatedError.mjs";

import { collectFields as n } from "../execution/collectFields.mjs";

import { getArgumentValues as s } from "../execution/values.mjs";

import { assertValidExecutionArguments as c, buildExecutionContext as m, getFieldDef as u, buildResolveInfo as v, execute as l } from "../execution/execute.mjs";

import { getOperationRootType as f } from "../utilities/getOperationRootType.mjs";

import { mapAsyncIterator as p } from "./mapAsyncIterator.mjs";

async function subscribe(r) {
  var t = r.schema;
  var a = r.document;
  var o = r.rootValue;
  var i = r.contextValue;
  var n = r.variableValues;
  var s = r.operationName;
  var c = r.fieldResolver;
  var m = r.subscribeFieldResolver;
  var u = await createSourceEventStream(t, a, o, i, n, s, m);
  if (!e(u)) {
    return u;
  }
  return p(u, (function(r) {
    return l({
      schema: t,
      document: a,
      rootValue: r,
      contextValue: i,
      variableValues: n,
      operationName: s,
      fieldResolver: c
    });
  }));
}

async function createSourceEventStream(l, p, b, d, h, j, w) {
  c(l);
  try {
    var S = m(l, p, b, d, h, j, w);
    if (!("schema" in S)) {
      return {
        errors: S
      };
    }
    var x = await async function executeSubscription(r) {
      var e = r.schema;
      var c = r.fragments;
      var m = r.operation;
      var l = r.variableValues;
      var p = r.rootValue;
      var b = f(e, m);
      var d = n(e, c, l, b, m.selectionSet, new Map, new Set);
      var h = [].concat(d.entries())[0];
      var j = h[0];
      var w = h[1];
      var S = u(e, b, w[0]);
      if (!S) {
        throw new o('The subscription field "' + w[0].name.value + '" is not defined.', w);
      }
      var x = a(void 0, j, b.name);
      var y = v(r, S, w, b, x);
      try {
        var V;
        var E = s(S, w[0], l);
        var R = r.contextValue;
        var A = null !== (V = S.subscribe) && void 0 !== V ? V : r.fieldResolver;
        var I = await A(p, E, R, y);
        if (I instanceof Error) {
          throw I;
        }
        return I;
      } catch (r) {
        throw i(r, w, t(x));
      }
    }(S);
    if (!e(x)) {
      throw new Error("Subscription field must return Async Iterable. Received: " + r(x) + ".");
    }
    return x;
  } catch (r) {
    if (r instanceof o) {
      return {
        errors: [ r ]
      };
    }
    throw r;
  }
}

export { createSourceEventStream, subscribe };
