"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/inspect.js");

var t = require("../jsutils/keyMap.js");

var n = require("../jsutils/mapValue.js");

var i = require("../jsutils/toObjMap.js");

var s = require("../jsutils/keyValMap.js");

var r = require("../jsutils/instanceOf.js");

var o = require("../jsutils/didYouMean.js");

var p = require("../jsutils/identityFunc.js");

var a = require("../jsutils/suggestionList.js");

var u = require("../error/GraphQLError.js");

var c = require("../language/kinds.js");

var f = require("../language/printer.js");

var y = require("../utilities/valueFromASTUntyped.js");

function isType(e) {
  return isScalarType(e) || isObjectType(e) || isInterfaceType(e) || isUnionType(e) || isEnumType(e) || isInputObjectType(e) || isListType(e) || isNonNullType(e);
}

function isScalarType(e) {
  return r.instanceOf(e, T);
}

function isObjectType(e) {
  return r.instanceOf(e, h);
}

function isInterfaceType(e) {
  return r.instanceOf(e, x);
}

function isUnionType(e) {
  return r.instanceOf(e, N);
}

function isEnumType(e) {
  return r.instanceOf(e, g);
}

function isInputObjectType(e) {
  return r.instanceOf(e, v);
}

function isListType(e) {
  return r.instanceOf(e, d);
}

function isNonNullType(e) {
  return r.instanceOf(e, l);
}

function isInputType(e) {
  return isScalarType(e) || isEnumType(e) || isInputObjectType(e) || isWrappingType(e) && isInputType(e.ofType);
}

function isOutputType(e) {
  return isScalarType(e) || isObjectType(e) || isInterfaceType(e) || isUnionType(e) || isEnumType(e) || isWrappingType(e) && isOutputType(e.ofType);
}

function isLeafType(e) {
  return isScalarType(e) || isEnumType(e);
}

var d = function GraphQLList(e) {
  isType(e);
  this.ofType = e;
};

d.prototype.toString = function toString() {
  return "[" + String(this.ofType) + "]";
};

d.prototype.toJSON = function toJSON() {
  return this.toString();
};

var l = function GraphQLNonNull(e) {
  isNullableType(e);
  this.ofType = e;
};

l.prototype.toString = function toString() {
  return String(this.ofType) + "!";
};

l.prototype.toJSON = function toJSON() {
  return this.toString();
};

function isWrappingType(e) {
  return isListType(e) || isNonNullType(e);
}

function isNullableType(e) {
  return isType(e) && !isNonNullType(e);
}

function isNamedType(e) {
  return isScalarType(e) || isObjectType(e) || isInterfaceType(e) || isUnionType(e) || isEnumType(e) || isInputObjectType(e);
}

function resolveReadonlyArrayThunk(e) {
  return "function" == typeof e ? e() : e;
}

function resolveObjMapThunk(e) {
  return "function" == typeof e ? e() : e;
}

var T = function GraphQLScalarType(e) {
  var t, n, s, r;
  var o = null !== (t = e.parseValue) && void 0 !== t ? t : p.identityFunc;
  this.name = e.name;
  this.description = e.description;
  this.specifiedByURL = e.specifiedByURL;
  this.serialize = null !== (n = e.serialize) && void 0 !== n ? n : p.identityFunc;
  this.parseValue = o;
  this.parseLiteral = null !== (s = e.parseLiteral) && void 0 !== s ? s : function(e, t) {
    return o(y.valueFromASTUntyped(e, t));
  };
  this.extensions = e.extensions && i.toObjMap(e.extensions);
  this.astNode = e.astNode;
  this.extensionASTNodes = null !== (r = e.extensionASTNodes) && void 0 !== r ? r : [];
};

T.prototype.toConfig = function toConfig() {
  return {
    name: this.name,
    description: this.description,
    specifiedByURL: this.specifiedByURL,
    serialize: this.serialize,
    parseValue: this.parseValue,
    parseLiteral: this.parseLiteral,
    extensions: this.extensions,
    astNode: this.astNode,
    extensionASTNodes: this.extensionASTNodes
  };
};

T.prototype.toString = function toString() {
  return this.name;
};

T.prototype.toJSON = function toJSON() {
  return this.toString();
};

var h = function GraphQLObjectType(e) {
  var t;
  this.name = e.name;
  this.description = e.description;
  this.isTypeOf = e.isTypeOf;
  this.extensions = e.extensions && i.toObjMap(e.extensions);
  this.astNode = e.astNode;
  this.extensionASTNodes = null !== (t = e.extensionASTNodes) && void 0 !== t ? t : [];
  this._fields = function() {
    return defineFieldMap(e);
  };
  this._interfaces = function() {
    return defineInterfaces(e);
  };
};

h.prototype.getFields = function getFields() {
  if ("function" == typeof this._fields) {
    this._fields = this._fields();
  }
  return this._fields;
};

h.prototype.getInterfaces = function getInterfaces() {
  if ("function" == typeof this._interfaces) {
    this._interfaces = this._interfaces();
  }
  return this._interfaces;
};

h.prototype.toConfig = function toConfig() {
  return {
    name: this.name,
    description: this.description,
    interfaces: this.getInterfaces(),
    fields: fieldsToFieldsConfig(this.getFields()),
    isTypeOf: this.isTypeOf,
    extensions: this.extensions,
    astNode: this.astNode,
    extensionASTNodes: this.extensionASTNodes
  };
};

h.prototype.toString = function toString() {
  return this.name;
};

h.prototype.toJSON = function toJSON() {
  return this.toString();
};

function defineInterfaces(e) {
  var t;
  return resolveReadonlyArrayThunk(null !== (t = e.interfaces) && void 0 !== t ? t : []);
}

function defineFieldMap(e) {
  var t = resolveObjMapThunk(e.fields);
  return n.mapValue(t, (function(e, t) {
    var n;
    var s = null !== (n = e.args) && void 0 !== n ? n : {};
    return {
      name: t,
      description: e.description,
      type: e.type,
      args: defineArguments(s),
      resolve: e.resolve,
      subscribe: e.subscribe,
      deprecationReason: e.deprecationReason,
      extensions: e.extensions && i.toObjMap(e.extensions),
      astNode: e.astNode
    };
  }));
}

function defineArguments(e) {
  return Object.entries(e).map((function(e) {
    var t = e[1];
    return {
      name: e[0],
      description: t.description,
      type: t.type,
      defaultValue: t.defaultValue,
      deprecationReason: t.deprecationReason,
      extensions: t.extensions && i.toObjMap(t.extensions),
      astNode: t.astNode
    };
  }));
}

function fieldsToFieldsConfig(e) {
  return n.mapValue(e, (function(e) {
    return {
      description: e.description,
      type: e.type,
      args: argsToArgsConfig(e.args),
      resolve: e.resolve,
      subscribe: e.subscribe,
      deprecationReason: e.deprecationReason,
      extensions: e.extensions,
      astNode: e.astNode
    };
  }));
}

function argsToArgsConfig(e) {
  return s.keyValMap(e, (function(e) {
    return e.name;
  }), (function(e) {
    return {
      description: e.description,
      type: e.type,
      defaultValue: e.defaultValue,
      deprecationReason: e.deprecationReason,
      extensions: e.extensions,
      astNode: e.astNode
    };
  }));
}

var x = function GraphQLInterfaceType(e) {
  var t;
  this.name = e.name;
  this.description = e.description;
  this.resolveType = e.resolveType;
  this.extensions = e.extensions && i.toObjMap(e.extensions);
  this.astNode = e.astNode;
  this.extensionASTNodes = null !== (t = e.extensionASTNodes) && void 0 !== t ? t : [];
  this._fields = defineFieldMap.bind(void 0, e);
  this._interfaces = defineInterfaces.bind(void 0, e);
};

x.prototype.getFields = function getFields() {
  if ("function" == typeof this._fields) {
    this._fields = this._fields();
  }
  return this._fields;
};

x.prototype.getInterfaces = function getInterfaces() {
  if ("function" == typeof this._interfaces) {
    this._interfaces = this._interfaces();
  }
  return this._interfaces;
};

x.prototype.toConfig = function toConfig() {
  return {
    name: this.name,
    description: this.description,
    interfaces: this.getInterfaces(),
    fields: fieldsToFieldsConfig(this.getFields()),
    resolveType: this.resolveType,
    extensions: this.extensions,
    astNode: this.astNode,
    extensionASTNodes: this.extensionASTNodes
  };
};

x.prototype.toString = function toString() {
  return this.name;
};

x.prototype.toJSON = function toJSON() {
  return this.toString();
};

var N = function GraphQLUnionType(e) {
  var t;
  this.name = e.name;
  this.description = e.description;
  this.resolveType = e.resolveType;
  this.extensions = e.extensions && i.toObjMap(e.extensions);
  this.astNode = e.astNode;
  this.extensionASTNodes = null !== (t = e.extensionASTNodes) && void 0 !== t ? t : [];
  this._types = defineTypes.bind(void 0, e);
};

N.prototype.getTypes = function getTypes() {
  if ("function" == typeof this._types) {
    this._types = this._types();
  }
  return this._types;
};

N.prototype.toConfig = function toConfig() {
  return {
    name: this.name,
    description: this.description,
    types: this.getTypes(),
    resolveType: this.resolveType,
    extensions: this.extensions,
    astNode: this.astNode,
    extensionASTNodes: this.extensionASTNodes
  };
};

N.prototype.toString = function toString() {
  return this.name;
};

N.prototype.toJSON = function toJSON() {
  return this.toString();
};

function defineTypes(e) {
  return resolveReadonlyArrayThunk(e.types);
}

var g = function GraphQLEnumType(e) {
  var n;
  this.name = e.name;
  this.description = e.description;
  this.extensions = e.extensions && i.toObjMap(e.extensions);
  this.astNode = e.astNode;
  this.extensionASTNodes = null !== (n = e.extensionASTNodes) && void 0 !== n ? n : [];
  this._values = function defineEnumValues(e, t) {
    return Object.entries(t).map((function(e) {
      var t = e[0];
      var n = e[1];
      return {
        name: t,
        description: n.description,
        value: void 0 !== n.value ? n.value : t,
        deprecationReason: n.deprecationReason,
        extensions: n.extensions && i.toObjMap(n.extensions),
        astNode: n.astNode
      };
    }));
  }(0, e.values);
  this._valueLookup = new Map(this._values.map((function(e) {
    return [ e.value, e ];
  })));
  this._nameLookup = t.keyMap(this._values, (function(e) {
    return e.name;
  }));
};

g.prototype.getValues = function getValues() {
  return this._values;
};

g.prototype.getValue = function getValue(e) {
  return this._nameLookup[e];
};

g.prototype.serialize = function serialize(t) {
  var n = this._valueLookup.get(t);
  if (void 0 === n) {
    throw new u.GraphQLError('Enum "' + this.name + '" cannot represent value: ' + e.inspect(t));
  }
  return n.name;
};

g.prototype.parseValue = function parseValue(t) {
  if ("string" != typeof t) {
    var n = e.inspect(t);
    throw new u.GraphQLError('Enum "' + this.name + '" cannot represent non-string value: ' + n + "." + didYouMeanEnumValue(this, n));
  }
  var i = this.getValue(t);
  if (null == i) {
    throw new u.GraphQLError('Value "' + t + '" does not exist in "' + this.name + '" enum.' + didYouMeanEnumValue(this, t));
  }
  return i.value;
};

g.prototype.parseLiteral = function parseLiteral(e, t) {
  if (e.kind !== c.Kind.ENUM) {
    var n = f.print(e);
    throw new u.GraphQLError('Enum "' + this.name + '" cannot represent non-enum value: ' + n + "." + didYouMeanEnumValue(this, n), e);
  }
  var i = this.getValue(e.value);
  if (null == i) {
    var s = f.print(e);
    throw new u.GraphQLError('Value "' + s + '" does not exist in "' + this.name + '" enum.' + didYouMeanEnumValue(this, s), e);
  }
  return i.value;
};

g.prototype.toConfig = function toConfig() {
  var e = s.keyValMap(this.getValues(), (function(e) {
    return e.name;
  }), (function(e) {
    return {
      description: e.description,
      value: e.value,
      deprecationReason: e.deprecationReason,
      extensions: e.extensions,
      astNode: e.astNode
    };
  }));
  return {
    name: this.name,
    description: this.description,
    values: e,
    extensions: this.extensions,
    astNode: this.astNode,
    extensionASTNodes: this.extensionASTNodes
  };
};

g.prototype.toString = function toString() {
  return this.name;
};

g.prototype.toJSON = function toJSON() {
  return this.toString();
};

function didYouMeanEnumValue(e, t) {
  var n = e.getValues().map((function(e) {
    return e.name;
  }));
  var i = a.suggestionList(t, n);
  return o.didYouMean("the enum value", i);
}

var v = function GraphQLInputObjectType(e) {
  var t;
  this.name = e.name;
  this.description = e.description;
  this.extensions = e.extensions && i.toObjMap(e.extensions);
  this.astNode = e.astNode;
  this.extensionASTNodes = null !== (t = e.extensionASTNodes) && void 0 !== t ? t : [];
  this._fields = defineInputFieldMap.bind(void 0, e);
};

v.prototype.getFields = function getFields() {
  if ("function" == typeof this._fields) {
    this._fields = this._fields();
  }
  return this._fields;
};

v.prototype.toConfig = function toConfig() {
  var e = n.mapValue(this.getFields(), (function(e) {
    return {
      description: e.description,
      type: e.type,
      defaultValue: e.defaultValue,
      extensions: e.extensions,
      astNode: e.astNode
    };
  }));
  return {
    name: this.name,
    description: this.description,
    fields: e,
    extensions: this.extensions,
    astNode: this.astNode,
    extensionASTNodes: this.extensionASTNodes
  };
};

v.prototype.toString = function toString() {
  return this.name;
};

v.prototype.toJSON = function toJSON() {
  return this.toString();
};

function defineInputFieldMap(e) {
  var t = resolveObjMapThunk(e.fields);
  return n.mapValue(t, (function(e, t) {
    return {
      name: t,
      description: e.description,
      type: e.type,
      defaultValue: e.defaultValue,
      deprecationReason: e.deprecationReason,
      extensions: e.extensions && i.toObjMap(e.extensions),
      astNode: e.astNode
    };
  }));
}

exports.GraphQLEnumType = g;

exports.GraphQLInputObjectType = v;

exports.GraphQLInterfaceType = x;

exports.GraphQLList = d;

exports.GraphQLNonNull = l;

exports.GraphQLObjectType = h;

exports.GraphQLScalarType = T;

exports.GraphQLUnionType = N;

exports.argsToArgsConfig = argsToArgsConfig;

exports.assertEnumType = function assertEnumType(t) {
  if (!isEnumType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Enum type.");
  }
  return t;
};

exports.assertInputObjectType = function assertInputObjectType(t) {
  if (!isInputObjectType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Input Object type.");
  }
  return t;
};

exports.assertInputType = function assertInputType(t) {
  if (!isInputType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL input type.");
  }
  return t;
};

exports.assertInterfaceType = function assertInterfaceType(t) {
  if (!isInterfaceType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Interface type.");
  }
  return t;
};

exports.assertLeafType = function assertLeafType(t) {
  if (!isLeafType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL leaf type.");
  }
  return t;
};

exports.assertListType = function assertListType(t) {
  if (!isListType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL List type.");
  }
  return t;
};

exports.assertNamedType = function assertNamedType(t) {
  if (!isNamedType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL named type.");
  }
  return t;
};

exports.assertNonNullType = function assertNonNullType(t) {
  if (!isNonNullType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Non-Null type.");
  }
  return t;
};

exports.assertNullableType = function assertNullableType(t) {
  if (!isNullableType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL nullable type.");
  }
  return t;
};

exports.assertObjectType = function assertObjectType(t) {
  if (!isObjectType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Object type.");
  }
  return t;
};

exports.assertOutputType = function assertOutputType(t) {
  if (!isOutputType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL output type.");
  }
  return t;
};

exports.assertScalarType = function assertScalarType(t) {
  if (!isScalarType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Scalar type.");
  }
  return t;
};

exports.assertType = function assertType(t) {
  if (!isType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL type.");
  }
  return t;
};

exports.assertUnionType = function assertUnionType(t) {
  if (!isUnionType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL Union type.");
  }
  return t;
};

exports.assertWrappingType = function assertWrappingType(t) {
  if (!isWrappingType(t)) {
    throw new Error("Expected " + e.inspect(t) + " to be a GraphQL wrapping type.");
  }
  return t;
};

exports.defineArguments = defineArguments;

exports.getNamedType = function getNamedType(e) {
  if (e) {
    var t = e;
    while (isWrappingType(t)) {
      t = t.ofType;
    }
    return t;
  }
};

exports.getNullableType = function getNullableType(e) {
  if (e) {
    return isNonNullType(e) ? e.ofType : e;
  }
};

exports.isAbstractType = function isAbstractType(e) {
  return isInterfaceType(e) || isUnionType(e);
};

exports.isCompositeType = function isCompositeType(e) {
  return isObjectType(e) || isInterfaceType(e) || isUnionType(e);
};

exports.isEnumType = isEnumType;

exports.isInputObjectType = isInputObjectType;

exports.isInputType = isInputType;

exports.isInterfaceType = isInterfaceType;

exports.isLeafType = isLeafType;

exports.isListType = isListType;

exports.isNamedType = isNamedType;

exports.isNonNullType = isNonNullType;

exports.isNullableType = isNullableType;

exports.isObjectType = isObjectType;

exports.isOutputType = isOutputType;

exports.isRequiredArgument = function isRequiredArgument(e) {
  return isNonNullType(e.type) && void 0 === e.defaultValue;
};

exports.isRequiredInputField = function isRequiredInputField(e) {
  return isNonNullType(e.type) && void 0 === e.defaultValue;
};

exports.isScalarType = isScalarType;

exports.isType = isType;

exports.isUnionType = isUnionType;

exports.isWrappingType = isWrappingType;
