"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/inspect.js");

var r = require("../jsutils/invariant.js");

var i = require("../jsutils/isObjectLike.js");

var n = require("../jsutils/isIterableObject.js");

var t = require("../language/kinds.js");

var u = require("../type/scalars.js");

var a = require("../type/definition.js");

var s = /^-?(?:0|[1-9][0-9]*)$/;

exports.astFromValue = function astFromValue(l, v) {
  if (a.isNonNullType(v)) {
    var d = astFromValue(l, v.ofType);
    if ((null == d ? void 0 : d.kind) === t.Kind.NULL) {
      return null;
    }
    return d;
  }
  if (null === l) {
    return {
      kind: t.Kind.NULL
    };
  }
  if (void 0 === l) {
    return null;
  }
  if (a.isListType(v)) {
    var f = v.ofType;
    if (n.isIterableObject(l)) {
      var o = [];
      for (var p = 0, j = l; p < j.length; p += 1) {
        var T = astFromValue(j[p], f);
        if (null != T) {
          o.push(T);
        }
      }
      return {
        kind: t.Kind.LIST,
        values: o
      };
    }
    return astFromValue(l, f);
  }
  if (a.isInputObjectType(v)) {
    if (!i.isObjectLike(l)) {
      return null;
    }
    var k = [];
    for (var y = 0, c = Object.values(v.getFields()); y < c.length; y += 1) {
      var L = c[y];
      var b = astFromValue(l[L.name], L.type);
      if (b) {
        k.push({
          kind: t.Kind.OBJECT_FIELD,
          name: {
            kind: t.Kind.NAME,
            value: L.name
          },
          value: b
        });
      }
    }
    return {
      kind: t.Kind.OBJECT,
      fields: k
    };
  }
  if (a.isLeafType(v)) {
    var m = v.serialize(l);
    if (null == m) {
      return null;
    }
    if ("boolean" == typeof m) {
      return {
        kind: t.Kind.BOOLEAN,
        value: m
      };
    }
    if ("number" == typeof m && Number.isFinite(m)) {
      var K = String(m);
      return s.test(K) ? {
        kind: t.Kind.INT,
        value: K
      } : {
        kind: t.Kind.FLOAT,
        value: K
      };
    }
    if ("string" == typeof m) {
      if (a.isEnumType(v)) {
        return {
          kind: t.Kind.ENUM,
          value: m
        };
      }
      if (v === u.GraphQLID && s.test(m)) {
        return {
          kind: t.Kind.INT,
          value: m
        };
      }
      return {
        kind: t.Kind.STRING,
        value: m
      };
    }
    throw new TypeError("Cannot convert value to AST: " + e.inspect(m) + ".");
  }
  r.invariant(!1);
};
