import { inspect as r } from "../jsutils/inspect.mjs";

import { invariant as e } from "../jsutils/invariant.mjs";

import { isObjectLike as i } from "../jsutils/isObjectLike.mjs";

import { isIterableObject as t } from "../jsutils/isIterableObject.mjs";

import { Kind as n } from "../language/kinds.mjs";

import { GraphQLID as u } from "../type/scalars.mjs";

import { isNonNullType as a, isListType as l, isInputObjectType as o, isLeafType as s, isEnumType as f } from "../type/definition.mjs";

function astFromValue(v, p) {
  if (a(p)) {
    var d = astFromValue(v, p.ofType);
    if ((null == d ? void 0 : d.kind) === n.NULL) {
      return null;
    }
    return d;
  }
  if (null === v) {
    return {
      kind: n.NULL
    };
  }
  if (void 0 === v) {
    return null;
  }
  if (l(p)) {
    var j = p.ofType;
    if (t(v)) {
      var k = [];
      for (var T = 0, F = v; T < F.length; T += 1) {
        var y = astFromValue(F[T], j);
        if (null != y) {
          k.push(y);
        }
      }
      return {
        kind: n.LIST,
        values: k
      };
    }
    return astFromValue(v, j);
  }
  if (o(p)) {
    if (!i(v)) {
      return null;
    }
    var L = [];
    for (var N = 0, O = Object.values(p.getFields()); N < O.length; N += 1) {
      var b = O[N];
      var c = astFromValue(v[b.name], b.type);
      if (c) {
        L.push({
          kind: n.OBJECT_FIELD,
          name: {
            kind: n.NAME,
            value: b.name
          },
          value: c
        });
      }
    }
    return {
      kind: n.OBJECT,
      fields: L
    };
  }
  if (s(p)) {
    var g = p.serialize(v);
    if (null == g) {
      return null;
    }
    if ("boolean" == typeof g) {
      return {
        kind: n.BOOLEAN,
        value: g
      };
    }
    if ("number" == typeof g && Number.isFinite(g)) {
      var E = String(g);
      return m.test(E) ? {
        kind: n.INT,
        value: E
      } : {
        kind: n.FLOAT,
        value: E
      };
    }
    if ("string" == typeof g) {
      if (f(p)) {
        return {
          kind: n.ENUM,
          value: g
        };
      }
      if (p === u && m.test(g)) {
        return {
          kind: n.INT,
          value: g
        };
      }
      return {
        kind: n.STRING,
        value: g
      };
    }
    throw new TypeError("Cannot convert value to AST: " + r(g) + ".");
  }
  e(!1);
}

var m = /^-?(?:0|[1-9][0-9]*)$/;

export { astFromValue };
