"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/inspect.js");

var r = require("../jsutils/invariant.js");

var t = require("../jsutils/didYouMean.js");

var a = require("../jsutils/isObjectLike.js");

var i = require("../jsutils/suggestionList.js");

var n = require("../jsutils/printPathArray.js");

var u = require("../jsutils/Path.js");

var o = require("../jsutils/isIterableObject.js");

var s = require("../error/GraphQLError.js");

var p = require("../type/definition.js");

function defaultOnError(r, t, a) {
  var i = "Invalid value " + e.inspect(t);
  if (r.length > 0) {
    i += ' at "value' + n.printPathArray(r) + '"';
  }
  a.message = i + ": " + a.message;
  throw a;
}

function coerceInputValueImpl(n, l, c, v) {
  if (p.isNonNullType(l)) {
    if (null != n) {
      return coerceInputValueImpl(n, l.ofType, c, v);
    }
    c(u.pathToArray(v), n, new s.GraphQLError('Expected non-nullable type "' + e.inspect(l) + '" not to be null.'));
    return;
  }
  if (null == n) {
    return null;
  }
  if (p.isListType(l)) {
    var d = l.ofType;
    if (o.isIterableObject(n)) {
      return Array.from(n, (function(e, r) {
        var t = u.addPath(v, r, void 0);
        return coerceInputValueImpl(e, d, c, t);
      }));
    }
    return [ coerceInputValueImpl(n, d, c, v) ];
  }
  if (p.isInputObjectType(l)) {
    if (!a.isObjectLike(n)) {
      c(u.pathToArray(v), n, new s.GraphQLError('Expected type "' + l.name + '" to be an object.'));
      return;
    }
    var f = {};
    var y = l.getFields();
    for (var j = 0, h = Object.values(y); j < h.length; j += 1) {
      var m = h[j];
      var I = n[m.name];
      if (void 0 === I) {
        if (void 0 !== m.defaultValue) {
          f[m.name] = m.defaultValue;
        } else if (p.isNonNullType(m.type)) {
          var b = e.inspect(m.type);
          c(u.pathToArray(v), n, new s.GraphQLError('Field "' + m.name + '" of required type "' + b + '" was not provided.'));
        }
        continue;
      }
      f[m.name] = coerceInputValueImpl(I, m.type, c, u.addPath(v, m.name, l.name));
    }
    for (var E = 0, L = Object.keys(n); E < L.length; E += 1) {
      var T = L[E];
      if (!y[T]) {
        var g = i.suggestionList(T, Object.keys(l.getFields()));
        c(u.pathToArray(v), n, new s.GraphQLError('Field "' + T + '" is not defined by type "' + l.name + '".' + t.didYouMean(g)));
      }
    }
    return f;
  }
  if (p.isLeafType(l)) {
    var q;
    try {
      q = l.parseValue(n);
    } catch (e) {
      if (e instanceof s.GraphQLError) {
        c(u.pathToArray(v), n, e);
      } else {
        c(u.pathToArray(v), n, new s.GraphQLError('Expected type "' + l.name + '". ' + e.message, void 0, void 0, void 0, void 0, e));
      }
      return;
    }
    if (void 0 === q) {
      c(u.pathToArray(v), n, new s.GraphQLError('Expected type "' + l.name + '".'));
    }
    return q;
  }
  r.invariant(!1);
}

exports.coerceInputValue = function coerceInputValue(e, r, t) {
  if (void 0 === t) {
    t = defaultOnError;
  }
  return coerceInputValueImpl(e, r, t, void 0);
};
