import { inspect as e } from "../jsutils/inspect.mjs";

import { invariant as r } from "../jsutils/invariant.mjs";

import { didYouMean as t } from "../jsutils/didYouMean.mjs";

import { isObjectLike as n } from "../jsutils/isObjectLike.mjs";

import { suggestionList as i } from "../jsutils/suggestionList.mjs";

import { printPathArray as o } from "../jsutils/printPathArray.mjs";

import { pathToArray as a, addPath as u } from "../jsutils/Path.mjs";

import { isIterableObject as l } from "../jsutils/isIterableObject.mjs";

import { GraphQLError as m } from "../error/GraphQLError.mjs";

import { isNonNullType as s, isListType as p, isInputObjectType as f, isLeafType as c } from "../type/definition.mjs";

function coerceInputValue(e, r, t) {
  if (void 0 === t) {
    t = defaultOnError;
  }
  return coerceInputValueImpl(e, r, t, void 0);
}

function defaultOnError(r, t, n) {
  var i = "Invalid value " + e(t);
  if (r.length > 0) {
    i += ' at "value' + o(r) + '"';
  }
  n.message = i + ": " + n.message;
  throw n;
}

function coerceInputValueImpl(o, d, v, j) {
  if (s(d)) {
    if (null != o) {
      return coerceInputValueImpl(o, d.ofType, v, j);
    }
    v(a(j), o, new m('Expected non-nullable type "' + e(d) + '" not to be null.'));
    return;
  }
  if (null == o) {
    return null;
  }
  if (p(d)) {
    var y = d.ofType;
    if (l(o)) {
      return Array.from(o, (function(e, r) {
        var t = u(j, r, void 0);
        return coerceInputValueImpl(e, y, v, t);
      }));
    }
    return [ coerceInputValueImpl(o, y, v, j) ];
  }
  if (f(d)) {
    if (!n(o)) {
      v(a(j), o, new m('Expected type "' + d.name + '" to be an object.'));
      return;
    }
    var I = {};
    var b = d.getFields();
    for (var V = 0, g = Object.values(b); V < g.length; V += 1) {
      var h = g[V];
      var w = o[h.name];
      if (void 0 === w) {
        if (void 0 !== h.defaultValue) {
          I[h.name] = h.defaultValue;
        } else if (s(h.type)) {
          var E = e(h.type);
          v(a(j), o, new m('Field "' + h.name + '" of required type "' + E + '" was not provided.'));
        }
        continue;
      }
      I[h.name] = coerceInputValueImpl(w, h.type, v, u(j, h.name, d.name));
    }
    for (var O = 0, x = Object.keys(o); O < x.length; O += 1) {
      var F = x[O];
      if (!b[F]) {
        var k = i(F, Object.keys(d.getFields()));
        v(a(j), o, new m('Field "' + F + '" is not defined by type "' + d.name + '".' + t(k)));
      }
    }
    return I;
  }
  if (c(d)) {
    var L;
    try {
      L = d.parseValue(o);
    } catch (e) {
      if (e instanceof m) {
        v(a(j), o, e);
      } else {
        v(a(j), o, new m('Expected type "' + d.name + '". ' + e.message, void 0, void 0, void 0, void 0, e));
      }
      return;
    }
    if (void 0 === L) {
      v(a(j), o, new m('Expected type "' + d.name + '".'));
    }
    return L;
  }
  r(!1);
}

export { coerceInputValue };
