"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/keyMap.js");

var n = require("../jsutils/mapValue.js");

var a = require("../jsutils/invariant.js");

var r = require("../language/kinds.js");

var t = require("../language/predicates.js");

var i = require("../validation/validate.js");

var o = require("../execution/values.js");

var u = require("../type/schema.js");

var s = require("../type/scalars.js");

var l = require("../type/introspection.js");

var d = require("../type/directives.js");

var p = require("../type/definition.js");

var c = require("./valueFromAST.js");

var v = e.keyMap(s.specifiedScalarTypes.concat(l.introspectionTypes), (function(e) {
  return e.name;
}));

function getDeprecationReason(e) {
  var n = o.getDirectiveValues(d.GraphQLDeprecatedDirective, e);
  return null == n ? void 0 : n.reason;
}

function getSpecifiedByURL(e) {
  var n = o.getDirectiveValues(d.GraphQLSpecifiedByDirective, e);
  return null == n ? void 0 : n.url;
}

exports.extendSchema = function extendSchema(e, o, f) {
  u.assertSchema(e);
  if (!0 !== (null == f ? void 0 : f.assumeValid) && !0 !== (null == f ? void 0 : f.assumeValidSDL)) {
    i.assertValidSDLExtension(o, e);
  }
  var T = e.toConfig();
  var y = function extendSchemaImpl(e, i, o) {
    var u, f, T, y;
    var g = [];
    var m = Object.create(null);
    var N = [];
    var b;
    var I = [];
    for (var j = 0, O = i.definitions; j < O.length; j += 1) {
      var h = O[j];
      if (h.kind === r.Kind.SCHEMA_DEFINITION) {
        b = h;
      } else if (h.kind === r.Kind.SCHEMA_EXTENSION) {
        I.push(h);
      } else if (t.isTypeDefinitionNode(h)) {
        g.push(h);
      } else if (t.isTypeExtensionNode(h)) {
        var x = h.name.value;
        var S = m[x];
        m[x] = S ? S.concat([ h ]) : [ h ];
      } else if (h.kind === r.Kind.DIRECTIVE_DEFINITION) {
        N.push(h);
      }
    }
    if (0 === Object.keys(m).length && 0 === g.length && 0 === N.length && 0 === I.length && null == b) {
      return e;
    }
    var E = Object.create(null);
    for (var L = 0, A = e.types; L < A.length; L += 1) {
      var D = A[L];
      E[D.name] = extendNamedType(D);
    }
    for (var w = 0, F = g; w < F.length; w += 1) {
      var M = F[w];
      var G;
      var Q = M.name.value;
      E[Q] = null !== (G = v[Q]) && void 0 !== G ? G : buildType(M);
    }
    var V = Object.assign({}, {
      query: e.query && replaceNamedType(e.query),
      mutation: e.mutation && replaceNamedType(e.mutation),
      subscription: e.subscription && replaceNamedType(e.subscription)
    }, b && getOperationTypes([ b ]), getOperationTypes(I));
    return Object.assign({}, {
      description: null === (u = b) || void 0 === u ? void 0 : null === (f = u.description) || void 0 === f ? void 0 : f.value
    }, V, {
      types: Object.values(E),
      directives: e.directives.map(replaceDirective).concat(N.map(buildDirective)),
      extensions: void 0,
      astNode: null !== (T = b) && void 0 !== T ? T : e.astNode,
      extensionASTNodes: e.extensionASTNodes.concat(I),
      assumeValid: null !== (y = null == o ? void 0 : o.assumeValid) && void 0 !== y ? y : !1
    });
    function replaceType(e) {
      if (p.isListType(e)) {
        return new p.GraphQLList(replaceType(e.ofType));
      }
      if (p.isNonNullType(e)) {
        return new p.GraphQLNonNull(replaceType(e.ofType));
      }
      return replaceNamedType(e);
    }
    function replaceNamedType(e) {
      return E[e.name];
    }
    function replaceDirective(e) {
      var a = e.toConfig();
      return new d.GraphQLDirective(Object.assign({}, a, {
        args: n.mapValue(a.args, extendArg)
      }));
    }
    function extendNamedType(e) {
      if (l.isIntrospectionType(e) || s.isSpecifiedScalarType(e)) {
        return e;
      }
      if (p.isScalarType(e)) {
        return extendScalarType(e);
      }
      if (p.isObjectType(e)) {
        return extendObjectType(e);
      }
      if (p.isInterfaceType(e)) {
        return extendInterfaceType(e);
      }
      if (p.isUnionType(e)) {
        return extendUnionType(e);
      }
      if (p.isEnumType(e)) {
        return extendEnumType(e);
      }
      if (p.isInputObjectType(e)) {
        return extendInputObjectType(e);
      }
      a.invariant(!1);
    }
    function extendInputObjectType(e) {
      var a;
      var r = e.toConfig();
      var t = null !== (a = m[r.name]) && void 0 !== a ? a : [];
      return new p.GraphQLInputObjectType(Object.assign({}, r, {
        fields: function() {
          return Object.assign({}, n.mapValue(r.fields, (function(e) {
            return Object.assign({}, e, {
              type: replaceType(e.type)
            });
          })), buildInputFieldMap(t));
        },
        extensionASTNodes: r.extensionASTNodes.concat(t)
      }));
    }
    function extendEnumType(e) {
      var n;
      var a = e.toConfig();
      var r = null !== (n = m[e.name]) && void 0 !== n ? n : [];
      return new p.GraphQLEnumType(Object.assign({}, a, {
        values: Object.assign({}, a.values, buildEnumValueMap(r)),
        extensionASTNodes: a.extensionASTNodes.concat(r)
      }));
    }
    function extendScalarType(e) {
      var n;
      var a = e.toConfig();
      var r = null !== (n = m[a.name]) && void 0 !== n ? n : [];
      var t = a.specifiedByURL;
      for (var i = 0, o = r; i < o.length; i += 1) {
        var u;
        t = null !== (u = getSpecifiedByURL(o[i])) && void 0 !== u ? u : t;
      }
      return new p.GraphQLScalarType(Object.assign({}, a, {
        specifiedByURL: t,
        extensionASTNodes: a.extensionASTNodes.concat(r)
      }));
    }
    function extendObjectType(e) {
      var a;
      var r = e.toConfig();
      var t = null !== (a = m[r.name]) && void 0 !== a ? a : [];
      return new p.GraphQLObjectType(Object.assign({}, r, {
        interfaces: function() {
          return e.getInterfaces().map(replaceNamedType).concat(buildInterfaces(t));
        },
        fields: function() {
          return Object.assign({}, n.mapValue(r.fields, extendField), buildFieldMap(t));
        },
        extensionASTNodes: r.extensionASTNodes.concat(t)
      }));
    }
    function extendInterfaceType(e) {
      var a;
      var r = e.toConfig();
      var t = null !== (a = m[r.name]) && void 0 !== a ? a : [];
      return new p.GraphQLInterfaceType(Object.assign({}, r, {
        interfaces: function() {
          return e.getInterfaces().map(replaceNamedType).concat(buildInterfaces(t));
        },
        fields: function() {
          return Object.assign({}, n.mapValue(r.fields, extendField), buildFieldMap(t));
        },
        extensionASTNodes: r.extensionASTNodes.concat(t)
      }));
    }
    function extendUnionType(e) {
      var n;
      var a = e.toConfig();
      var r = null !== (n = m[a.name]) && void 0 !== n ? n : [];
      return new p.GraphQLUnionType(Object.assign({}, a, {
        types: function() {
          return e.getTypes().map(replaceNamedType).concat(buildUnionTypes(r));
        },
        extensionASTNodes: a.extensionASTNodes.concat(r)
      }));
    }
    function extendField(e) {
      return Object.assign({}, e, {
        type: replaceType(e.type),
        args: e.args && n.mapValue(e.args, extendArg)
      });
    }
    function extendArg(e) {
      return Object.assign({}, e, {
        type: replaceType(e.type)
      });
    }
    function getOperationTypes(e) {
      var n = {};
      for (var a = 0, r = e; a < r.length; a += 1) {
        var t;
        for (var i = 0, o = null !== (t = r[a].operationTypes) && void 0 !== t ? t : []; i < o.length; i += 1) {
          var u = o[i];
          n[u.operation] = getNamedType(u.type);
        }
      }
      return n;
    }
    function getNamedType(e) {
      var n;
      var a = e.name.value;
      var r = null !== (n = v[a]) && void 0 !== n ? n : E[a];
      if (void 0 === r) {
        throw new Error('Unknown type: "' + a + '".');
      }
      return r;
    }
    function getWrappedType(e) {
      if (e.kind === r.Kind.LIST_TYPE) {
        return new p.GraphQLList(getWrappedType(e.type));
      }
      if (e.kind === r.Kind.NON_NULL_TYPE) {
        return new p.GraphQLNonNull(getWrappedType(e.type));
      }
      return getNamedType(e);
    }
    function buildDirective(e) {
      var n;
      return new d.GraphQLDirective({
        name: e.name.value,
        description: null === (n = e.description) || void 0 === n ? void 0 : n.value,
        locations: e.locations.map((function(e) {
          return e.value;
        })),
        isRepeatable: e.repeatable,
        args: buildArgumentMap(e.arguments),
        astNode: e
      });
    }
    function buildFieldMap(e) {
      var n = Object.create(null);
      for (var a = 0, r = e; a < r.length; a += 1) {
        var t;
        for (var i = 0, o = null !== (t = r[a].fields) && void 0 !== t ? t : []; i < o.length; i += 1) {
          var u = o[i];
          var s;
          n[u.name.value] = {
            type: getWrappedType(u.type),
            description: null === (s = u.description) || void 0 === s ? void 0 : s.value,
            args: buildArgumentMap(u.arguments),
            deprecationReason: getDeprecationReason(u),
            astNode: u
          };
        }
      }
      return n;
    }
    function buildArgumentMap(e) {
      var n = null != e ? e : [];
      var a = Object.create(null);
      for (var r = 0, t = n; r < t.length; r += 1) {
        var i = t[r];
        var o;
        var u = getWrappedType(i.type);
        a[i.name.value] = {
          type: u,
          description: null === (o = i.description) || void 0 === o ? void 0 : o.value,
          defaultValue: c.valueFromAST(i.defaultValue, u),
          deprecationReason: getDeprecationReason(i),
          astNode: i
        };
      }
      return a;
    }
    function buildInputFieldMap(e) {
      var n = Object.create(null);
      for (var a = 0, r = e; a < r.length; a += 1) {
        var t;
        for (var i = 0, o = null !== (t = r[a].fields) && void 0 !== t ? t : []; i < o.length; i += 1) {
          var u = o[i];
          var s;
          var l = getWrappedType(u.type);
          n[u.name.value] = {
            type: l,
            description: null === (s = u.description) || void 0 === s ? void 0 : s.value,
            defaultValue: c.valueFromAST(u.defaultValue, l),
            deprecationReason: getDeprecationReason(u),
            astNode: u
          };
        }
      }
      return n;
    }
    function buildEnumValueMap(e) {
      var n = Object.create(null);
      for (var a = 0, r = e; a < r.length; a += 1) {
        var t;
        for (var i = 0, o = null !== (t = r[a].values) && void 0 !== t ? t : []; i < o.length; i += 1) {
          var u = o[i];
          var s;
          n[u.name.value] = {
            description: null === (s = u.description) || void 0 === s ? void 0 : s.value,
            deprecationReason: getDeprecationReason(u),
            astNode: u
          };
        }
      }
      return n;
    }
    function buildInterfaces(e) {
      return e.flatMap((function(e) {
        var n, a;
        return null !== (n = null === (a = e.interfaces) || void 0 === a ? void 0 : a.map(getNamedType)) && void 0 !== n ? n : [];
      }));
    }
    function buildUnionTypes(e) {
      return e.flatMap((function(e) {
        var n, a;
        return null !== (n = null === (a = e.types) || void 0 === a ? void 0 : a.map(getNamedType)) && void 0 !== n ? n : [];
      }));
    }
    function buildType(e) {
      var n;
      var t = e.name.value;
      var i = null !== (n = m[t]) && void 0 !== n ? n : [];
      switch (e.kind) {
       case r.Kind.OBJECT_TYPE_DEFINITION:
        var o;
        var u = [ e ].concat(i);
        return new p.GraphQLObjectType({
          name: t,
          description: null === (o = e.description) || void 0 === o ? void 0 : o.value,
          interfaces: function() {
            return buildInterfaces(u);
          },
          fields: function() {
            return buildFieldMap(u);
          },
          astNode: e,
          extensionASTNodes: i
        });

       case r.Kind.INTERFACE_TYPE_DEFINITION:
        var s;
        var l = [ e ].concat(i);
        return new p.GraphQLInterfaceType({
          name: t,
          description: null === (s = e.description) || void 0 === s ? void 0 : s.value,
          interfaces: function() {
            return buildInterfaces(l);
          },
          fields: function() {
            return buildFieldMap(l);
          },
          astNode: e,
          extensionASTNodes: i
        });

       case r.Kind.ENUM_TYPE_DEFINITION:
        var d;
        var c = [ e ].concat(i);
        return new p.GraphQLEnumType({
          name: t,
          description: null === (d = e.description) || void 0 === d ? void 0 : d.value,
          values: buildEnumValueMap(c),
          astNode: e,
          extensionASTNodes: i
        });

       case r.Kind.UNION_TYPE_DEFINITION:
        var v;
        var f = [ e ].concat(i);
        return new p.GraphQLUnionType({
          name: t,
          description: null === (v = e.description) || void 0 === v ? void 0 : v.value,
          types: function() {
            return buildUnionTypes(f);
          },
          astNode: e,
          extensionASTNodes: i
        });

       case r.Kind.SCALAR_TYPE_DEFINITION:
        var T;
        return new p.GraphQLScalarType({
          name: t,
          description: null === (T = e.description) || void 0 === T ? void 0 : T.value,
          specifiedByURL: getSpecifiedByURL(e),
          astNode: e,
          extensionASTNodes: i
        });

       case r.Kind.INPUT_OBJECT_TYPE_DEFINITION:
        var y;
        var g = [ e ].concat(i);
        return new p.GraphQLInputObjectType({
          name: t,
          description: null === (y = e.description) || void 0 === y ? void 0 : y.value,
          fields: function() {
            return buildInputFieldMap(g);
          },
          astNode: e,
          extensionASTNodes: i
        });
      }
      a.invariant(!1);
    }
  }(T, o, f);
  return T === y ? e : new u.GraphQLSchema(y);
};
