import { keyMap as e } from "../jsutils/keyMap.mjs";

import { mapValue as n } from "../jsutils/mapValue.mjs";

import { invariant as t } from "../jsutils/invariant.mjs";

import { Kind as r } from "../language/kinds.mjs";

import { isTypeDefinitionNode as a, isTypeExtensionNode as i } from "../language/predicates.mjs";

import { assertValidSDLExtension as o } from "../validation/validate.mjs";

import { getDirectiveValues as u } from "../execution/values.mjs";

import { assertSchema as l, GraphQLSchema as d } from "../type/schema.mjs";

import { isSpecifiedScalarType as s, specifiedScalarTypes as c } from "../type/scalars.mjs";

import { isIntrospectionType as p, introspectionTypes as v } from "../type/introspection.mjs";

import { GraphQLDirective as f, GraphQLDeprecatedDirective as m, GraphQLSpecifiedByDirective as T } from "../type/directives.mjs";

import { isScalarType as y, GraphQLScalarType as g, isObjectType as N, GraphQLObjectType as b, isInterfaceType as x, GraphQLInterfaceType as I, isUnionType as j, GraphQLUnionType as O, isEnumType as S, GraphQLEnumType as E, isInputObjectType as A, GraphQLInputObjectType as h, GraphQLList as w, GraphQLNonNull as F, isListType as M, isNonNullType as D } from "../type/definition.mjs";

import { valueFromAST as R } from "./valueFromAST.mjs";

function extendSchema(e, u, c) {
  l(e);
  if (!0 !== (null == c ? void 0 : c.assumeValid) && !0 !== (null == c ? void 0 : c.assumeValidSDL)) {
    o(u, e);
  }
  var v = e.toConfig();
  var m = function extendSchemaImpl(e, o, u) {
    var l, d, c, v;
    var m = [];
    var T = Object.create(null);
    var U = [];
    var C;
    var V = [];
    for (var L = 0, k = o.definitions; L < k.length; L += 1) {
      var P = k[L];
      if (P.kind === r.SCHEMA_DEFINITION) {
        C = P;
      } else if (P.kind === r.SCHEMA_EXTENSION) {
        V.push(P);
      } else if (a(P)) {
        m.push(P);
      } else if (i(P)) {
        var B = P.name.value;
        var Y = T[B];
        T[B] = Y ? Y.concat([ P ]) : [ P ];
      } else if (P.kind === r.DIRECTIVE_DEFINITION) {
        U.push(P);
      }
    }
    if (0 === Object.keys(T).length && 0 === m.length && 0 === U.length && 0 === V.length && null == C) {
      return e;
    }
    var W = Object.create(null);
    for (var q = 0, H = e.types; q < H.length; q += 1) {
      var J = H[q];
      W[J.name] = extendNamedType(J);
    }
    for (var X = 0, z = m; X < z.length; X += 1) {
      var G = z[X];
      var K;
      var Q = G.name.value;
      W[Q] = null !== (K = _[Q]) && void 0 !== K ? K : buildType(G);
    }
    var Z = Object.assign({}, {
      query: e.query && replaceNamedType(e.query),
      mutation: e.mutation && replaceNamedType(e.mutation),
      subscription: e.subscription && replaceNamedType(e.subscription)
    }, C && getOperationTypes([ C ]), getOperationTypes(V));
    return Object.assign({}, {
      description: null === (l = C) || void 0 === l ? void 0 : null === (d = l.description) || void 0 === d ? void 0 : d.value
    }, Z, {
      types: Object.values(W),
      directives: e.directives.map(replaceDirective).concat(U.map(buildDirective)),
      extensions: void 0,
      astNode: null !== (c = C) && void 0 !== c ? c : e.astNode,
      extensionASTNodes: e.extensionASTNodes.concat(V),
      assumeValid: null !== (v = null == u ? void 0 : u.assumeValid) && void 0 !== v ? v : !1
    });
    function replaceType(e) {
      if (M(e)) {
        return new w(replaceType(e.ofType));
      }
      if (D(e)) {
        return new F(replaceType(e.ofType));
      }
      return replaceNamedType(e);
    }
    function replaceNamedType(e) {
      return W[e.name];
    }
    function replaceDirective(e) {
      var t = e.toConfig();
      return new f(Object.assign({}, t, {
        args: n(t.args, extendArg)
      }));
    }
    function extendNamedType(e) {
      if (p(e) || s(e)) {
        return e;
      }
      if (y(e)) {
        return extendScalarType(e);
      }
      if (N(e)) {
        return extendObjectType(e);
      }
      if (x(e)) {
        return extendInterfaceType(e);
      }
      if (j(e)) {
        return extendUnionType(e);
      }
      if (S(e)) {
        return extendEnumType(e);
      }
      if (A(e)) {
        return extendInputObjectType(e);
      }
      t(!1);
    }
    function extendInputObjectType(e) {
      var t;
      var r = e.toConfig();
      var a = null !== (t = T[r.name]) && void 0 !== t ? t : [];
      return new h(Object.assign({}, r, {
        fields: function() {
          return Object.assign({}, n(r.fields, (function(e) {
            return Object.assign({}, e, {
              type: replaceType(e.type)
            });
          })), buildInputFieldMap(a));
        },
        extensionASTNodes: r.extensionASTNodes.concat(a)
      }));
    }
    function extendEnumType(e) {
      var n;
      var t = e.toConfig();
      var r = null !== (n = T[e.name]) && void 0 !== n ? n : [];
      return new E(Object.assign({}, t, {
        values: Object.assign({}, t.values, buildEnumValueMap(r)),
        extensionASTNodes: t.extensionASTNodes.concat(r)
      }));
    }
    function extendScalarType(e) {
      var n;
      var t = e.toConfig();
      var r = null !== (n = T[t.name]) && void 0 !== n ? n : [];
      var a = t.specifiedByURL;
      for (var i = 0, o = r; i < o.length; i += 1) {
        var u;
        a = null !== (u = getSpecifiedByURL(o[i])) && void 0 !== u ? u : a;
      }
      return new g(Object.assign({}, t, {
        specifiedByURL: a,
        extensionASTNodes: t.extensionASTNodes.concat(r)
      }));
    }
    function extendObjectType(e) {
      var t;
      var r = e.toConfig();
      var a = null !== (t = T[r.name]) && void 0 !== t ? t : [];
      return new b(Object.assign({}, r, {
        interfaces: function() {
          return e.getInterfaces().map(replaceNamedType).concat(buildInterfaces(a));
        },
        fields: function() {
          return Object.assign({}, n(r.fields, extendField), buildFieldMap(a));
        },
        extensionASTNodes: r.extensionASTNodes.concat(a)
      }));
    }
    function extendInterfaceType(e) {
      var t;
      var r = e.toConfig();
      var a = null !== (t = T[r.name]) && void 0 !== t ? t : [];
      return new I(Object.assign({}, r, {
        interfaces: function() {
          return e.getInterfaces().map(replaceNamedType).concat(buildInterfaces(a));
        },
        fields: function() {
          return Object.assign({}, n(r.fields, extendField), buildFieldMap(a));
        },
        extensionASTNodes: r.extensionASTNodes.concat(a)
      }));
    }
    function extendUnionType(e) {
      var n;
      var t = e.toConfig();
      var r = null !== (n = T[t.name]) && void 0 !== n ? n : [];
      return new O(Object.assign({}, t, {
        types: function() {
          return e.getTypes().map(replaceNamedType).concat(buildUnionTypes(r));
        },
        extensionASTNodes: t.extensionASTNodes.concat(r)
      }));
    }
    function extendField(e) {
      return Object.assign({}, e, {
        type: replaceType(e.type),
        args: e.args && n(e.args, extendArg)
      });
    }
    function extendArg(e) {
      return Object.assign({}, e, {
        type: replaceType(e.type)
      });
    }
    function getOperationTypes(e) {
      var n = {};
      for (var t = 0, r = e; t < r.length; t += 1) {
        var a;
        for (var i = 0, o = null !== (a = r[t].operationTypes) && void 0 !== a ? a : []; i < o.length; i += 1) {
          var u = o[i];
          n[u.operation] = getNamedType(u.type);
        }
      }
      return n;
    }
    function getNamedType(e) {
      var n;
      var t = e.name.value;
      var r = null !== (n = _[t]) && void 0 !== n ? n : W[t];
      if (void 0 === r) {
        throw new Error('Unknown type: "' + t + '".');
      }
      return r;
    }
    function getWrappedType(e) {
      if (e.kind === r.LIST_TYPE) {
        return new w(getWrappedType(e.type));
      }
      if (e.kind === r.NON_NULL_TYPE) {
        return new F(getWrappedType(e.type));
      }
      return getNamedType(e);
    }
    function buildDirective(e) {
      var n;
      return new f({
        name: e.name.value,
        description: null === (n = e.description) || void 0 === n ? void 0 : n.value,
        locations: e.locations.map((function(e) {
          return e.value;
        })),
        isRepeatable: e.repeatable,
        args: buildArgumentMap(e.arguments),
        astNode: e
      });
    }
    function buildFieldMap(e) {
      var n = Object.create(null);
      for (var t = 0, r = e; t < r.length; t += 1) {
        var a;
        for (var i = 0, o = null !== (a = r[t].fields) && void 0 !== a ? a : []; i < o.length; i += 1) {
          var u = o[i];
          var l;
          n[u.name.value] = {
            type: getWrappedType(u.type),
            description: null === (l = u.description) || void 0 === l ? void 0 : l.value,
            args: buildArgumentMap(u.arguments),
            deprecationReason: getDeprecationReason(u),
            astNode: u
          };
        }
      }
      return n;
    }
    function buildArgumentMap(e) {
      var n = null != e ? e : [];
      var t = Object.create(null);
      for (var r = 0, a = n; r < a.length; r += 1) {
        var i = a[r];
        var o;
        var u = getWrappedType(i.type);
        t[i.name.value] = {
          type: u,
          description: null === (o = i.description) || void 0 === o ? void 0 : o.value,
          defaultValue: R(i.defaultValue, u),
          deprecationReason: getDeprecationReason(i),
          astNode: i
        };
      }
      return t;
    }
    function buildInputFieldMap(e) {
      var n = Object.create(null);
      for (var t = 0, r = e; t < r.length; t += 1) {
        var a;
        for (var i = 0, o = null !== (a = r[t].fields) && void 0 !== a ? a : []; i < o.length; i += 1) {
          var u = o[i];
          var l;
          var d = getWrappedType(u.type);
          n[u.name.value] = {
            type: d,
            description: null === (l = u.description) || void 0 === l ? void 0 : l.value,
            defaultValue: R(u.defaultValue, d),
            deprecationReason: getDeprecationReason(u),
            astNode: u
          };
        }
      }
      return n;
    }
    function buildEnumValueMap(e) {
      var n = Object.create(null);
      for (var t = 0, r = e; t < r.length; t += 1) {
        var a;
        for (var i = 0, o = null !== (a = r[t].values) && void 0 !== a ? a : []; i < o.length; i += 1) {
          var u = o[i];
          var l;
          n[u.name.value] = {
            description: null === (l = u.description) || void 0 === l ? void 0 : l.value,
            deprecationReason: getDeprecationReason(u),
            astNode: u
          };
        }
      }
      return n;
    }
    function buildInterfaces(e) {
      return e.flatMap((function(e) {
        var n, t;
        return null !== (n = null === (t = e.interfaces) || void 0 === t ? void 0 : t.map(getNamedType)) && void 0 !== n ? n : [];
      }));
    }
    function buildUnionTypes(e) {
      return e.flatMap((function(e) {
        var n, t;
        return null !== (n = null === (t = e.types) || void 0 === t ? void 0 : t.map(getNamedType)) && void 0 !== n ? n : [];
      }));
    }
    function buildType(e) {
      var n;
      var a = e.name.value;
      var i = null !== (n = T[a]) && void 0 !== n ? n : [];
      switch (e.kind) {
       case r.OBJECT_TYPE_DEFINITION:
        var o;
        var u = [ e ].concat(i);
        return new b({
          name: a,
          description: null === (o = e.description) || void 0 === o ? void 0 : o.value,
          interfaces: function() {
            return buildInterfaces(u);
          },
          fields: function() {
            return buildFieldMap(u);
          },
          astNode: e,
          extensionASTNodes: i
        });

       case r.INTERFACE_TYPE_DEFINITION:
        var l;
        var d = [ e ].concat(i);
        return new I({
          name: a,
          description: null === (l = e.description) || void 0 === l ? void 0 : l.value,
          interfaces: function() {
            return buildInterfaces(d);
          },
          fields: function() {
            return buildFieldMap(d);
          },
          astNode: e,
          extensionASTNodes: i
        });

       case r.ENUM_TYPE_DEFINITION:
        var s;
        var c = [ e ].concat(i);
        return new E({
          name: a,
          description: null === (s = e.description) || void 0 === s ? void 0 : s.value,
          values: buildEnumValueMap(c),
          astNode: e,
          extensionASTNodes: i
        });

       case r.UNION_TYPE_DEFINITION:
        var p;
        var v = [ e ].concat(i);
        return new O({
          name: a,
          description: null === (p = e.description) || void 0 === p ? void 0 : p.value,
          types: function() {
            return buildUnionTypes(v);
          },
          astNode: e,
          extensionASTNodes: i
        });

       case r.SCALAR_TYPE_DEFINITION:
        var f;
        return new g({
          name: a,
          description: null === (f = e.description) || void 0 === f ? void 0 : f.value,
          specifiedByURL: getSpecifiedByURL(e),
          astNode: e,
          extensionASTNodes: i
        });

       case r.INPUT_OBJECT_TYPE_DEFINITION:
        var m;
        var y = [ e ].concat(i);
        return new h({
          name: a,
          description: null === (m = e.description) || void 0 === m ? void 0 : m.value,
          fields: function() {
            return buildInputFieldMap(y);
          },
          astNode: e,
          extensionASTNodes: i
        });
      }
      t(!1);
    }
  }(v, u, c);
  return v === m ? e : new d(m);
}

var _ = e(c.concat(v), (function(e) {
  return e.name;
}));

function getDeprecationReason(e) {
  var n = u(m, e);
  return null == n ? void 0 : n.reason;
}

function getSpecifiedByURL(e) {
  var n = u(T, e);
  return null == n ? void 0 : n.url;
}

export { extendSchema };
