import { GraphQLError as r } from "../error/GraphQLError.mjs";

function getOperationRootType(o, e) {
  if ("query" === e.operation) {
    var t = o.getQueryType();
    if (!t) {
      throw new r("Schema does not define the required query root type.", e);
    }
    return t;
  }
  if ("mutation" === e.operation) {
    var i = o.getMutationType();
    if (!i) {
      throw new r("Schema is not configured for mutations.", e);
    }
    return i;
  }
  if ("subscription" === e.operation) {
    var n = o.getSubscriptionType();
    if (!n) {
      throw new r("Schema is not configured for subscriptions.", e);
    }
    return n;
  }
  throw new r("Can only have query, mutation and subscription operations.", e);
}

export { getOperationRootType };
