import { isNonNullType as e, isListType as r, isAbstractType as i, isInterfaceType as p, isObjectType as u } from "../type/definition.mjs";

function isEqualType(i, p) {
  if (i === p) {
    return !0;
  }
  if (e(i) && e(p)) {
    return isEqualType(i.ofType, p.ofType);
  }
  if (r(i) && r(p)) {
    return isEqualType(i.ofType, p.ofType);
  }
  return !1;
}

function isTypeSubTypeOf(f, y, T) {
  if (y === T) {
    return !0;
  }
  if (e(T)) {
    if (e(y)) {
      return isTypeSubTypeOf(f, y.ofType, T.ofType);
    }
    return !1;
  }
  if (e(y)) {
    return isTypeSubTypeOf(f, y.ofType, T);
  }
  if (r(T)) {
    if (r(y)) {
      return isTypeSubTypeOf(f, y.ofType, T.ofType);
    }
    return !1;
  }
  if (r(y)) {
    return !1;
  }
  return i(T) && (p(y) || u(y)) && f.isSubType(T, y);
}

function doTypesOverlap(e, r, p) {
  if (r === p) {
    return !0;
  }
  if (i(r)) {
    if (i(p)) {
      return e.getPossibleTypes(r).some((function(r) {
        return e.isSubType(p, r);
      }));
    }
    return e.isSubType(r, p);
  }
  if (i(p)) {
    return e.isSubType(p, r);
  }
  return !1;
}

export { doTypesOverlap, isEqualType, isTypeSubTypeOf };
