"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/keyMap.js");

var r = require("../jsutils/invariant.js");

var i = require("../language/kinds.js");

var n = require("../type/definition.js");

function isMissingVariable(e, r) {
  return e.kind === i.Kind.VARIABLE && (null == r || void 0 === r[e.name.value]);
}

exports.valueFromAST = function valueFromAST(u, a, t) {
  if (!u) {
    return;
  }
  if (u.kind === i.Kind.VARIABLE) {
    var l = u.name.value;
    if (null == t || void 0 === t[l]) {
      return;
    }
    var v = t[l];
    if (null === v && n.isNonNullType(a)) {
      return;
    }
    return v;
  }
  if (n.isNonNullType(a)) {
    if (u.kind === i.Kind.NULL) {
      return;
    }
    return valueFromAST(u, a.ofType, t);
  }
  if (u.kind === i.Kind.NULL) {
    return null;
  }
  if (n.isListType(a)) {
    var s = a.ofType;
    if (u.kind === i.Kind.LIST) {
      var f = [];
      for (var o = 0, d = u.values; o < d.length; o += 1) {
        var p = d[o];
        if (isMissingVariable(p, t)) {
          if (n.isNonNullType(s)) {
            return;
          }
          f.push(null);
        } else {
          var T = valueFromAST(p, s, t);
          if (void 0 === T) {
            return;
          }
          f.push(T);
        }
      }
      return f;
    }
    var y = valueFromAST(u, s, t);
    if (void 0 === y) {
      return;
    }
    return [ y ];
  }
  if (n.isInputObjectType(a)) {
    if (u.kind !== i.Kind.OBJECT) {
      return;
    }
    var c = Object.create(null);
    var m = e.keyMap(u.fields, (function(e) {
      return e.name.value;
    }));
    for (var j = 0, A = Object.values(a.getFields()); j < A.length; j += 1) {
      var L = A[j];
      var N = m[L.name];
      if (!N || isMissingVariable(N.value, t)) {
        if (void 0 !== L.defaultValue) {
          c[L.name] = L.defaultValue;
        } else if (n.isNonNullType(L.type)) {
          return;
        }
        continue;
      }
      var k = valueFromAST(N.value, L.type, t);
      if (void 0 === k) {
        return;
      }
      c[L.name] = k;
    }
    return c;
  }
  if (n.isLeafType(a)) {
    var g;
    try {
      g = a.parseLiteral(u, t);
    } catch (e) {
      return;
    }
    if (void 0 === g) {
      return;
    }
    return g;
  }
  r.invariant(!1);
};
