import { keyMap as r } from "../jsutils/keyMap.mjs";

import { invariant as e } from "../jsutils/invariant.mjs";

import { Kind as i } from "../language/kinds.mjs";

import { isNonNullType as n, isListType as a, isInputObjectType as u, isLeafType as t } from "../type/definition.mjs";

function valueFromAST(l, f, v) {
  if (!l) {
    return;
  }
  if (l.kind === i.VARIABLE) {
    var o = l.name.value;
    if (null == v || void 0 === v[o]) {
      return;
    }
    var s = v[o];
    if (null === s && n(f)) {
      return;
    }
    return s;
  }
  if (n(f)) {
    if (l.kind === i.NULL) {
      return;
    }
    return valueFromAST(l, f.ofType, v);
  }
  if (l.kind === i.NULL) {
    return null;
  }
  if (a(f)) {
    var m = f.ofType;
    if (l.kind === i.LIST) {
      var d = [];
      for (var p = 0, A = l.values; p < A.length; p += 1) {
        var T = A[p];
        if (isMissingVariable(T, v)) {
          if (n(m)) {
            return;
          }
          d.push(null);
        } else {
          var c = valueFromAST(T, m, v);
          if (void 0 === c) {
            return;
          }
          d.push(c);
        }
      }
      return d;
    }
    var g = valueFromAST(l, m, v);
    if (void 0 === g) {
      return;
    }
    return [ g ];
  }
  if (u(f)) {
    if (l.kind !== i.OBJECT) {
      return;
    }
    var j = Object.create(null);
    var k = r(l.fields, (function(r) {
      return r.name.value;
    }));
    for (var L = 0, y = Object.values(f.getFields()); L < y.length; L += 1) {
      var F = y[L];
      var S = k[F.name];
      if (!S || isMissingVariable(S.value, v)) {
        if (void 0 !== F.defaultValue) {
          j[F.name] = F.defaultValue;
        } else if (n(F.type)) {
          return;
        }
        continue;
      }
      var V = valueFromAST(S.value, F.type, v);
      if (void 0 === V) {
        return;
      }
      j[F.name] = V;
    }
    return j;
  }
  if (t(f)) {
    var b;
    try {
      b = f.parseLiteral(l, v);
    } catch (r) {
      return;
    }
    if (void 0 === b) {
      return;
    }
    return b;
  }
  e(!1);
}

function isMissingVariable(r, e) {
  return r.kind === i.VARIABLE && (null == e || void 0 === e[r.name.value]);
}

export { valueFromAST };
