"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../jsutils/invariant.js");

var n = require("../jsutils/keyValMap.js");

var r = require("../language/kinds.js");

exports.valueFromASTUntyped = function valueFromASTUntyped(a, u) {
  switch (a.kind) {
   case r.Kind.NULL:
    return null;

   case r.Kind.INT:
    return parseInt(a.value, 10);

   case r.Kind.FLOAT:
    return parseFloat(a.value);

   case r.Kind.STRING:
   case r.Kind.ENUM:
   case r.Kind.BOOLEAN:
    return a.value;

   case r.Kind.LIST:
    return a.values.map((function(e) {
      return valueFromASTUntyped(e, u);
    }));

   case r.Kind.OBJECT:
    return n.keyValMap(a.fields, (function(e) {
      return e.name.value;
    }), (function(e) {
      return valueFromASTUntyped(e.value, u);
    }));

   case r.Kind.VARIABLE:
    return null == u ? void 0 : u[a.name.value];
  }
  e.invariant(!1);
};
