import { invariant as e } from "../jsutils/invariant.mjs";

import { keyValMap as r } from "../jsutils/keyValMap.mjs";

import { Kind as a } from "../language/kinds.mjs";

function valueFromASTUntyped(n, u) {
  switch (n.kind) {
   case a.NULL:
    return null;

   case a.INT:
    return parseInt(n.value, 10);

   case a.FLOAT:
    return parseFloat(n.value);

   case a.STRING:
   case a.ENUM:
   case a.BOOLEAN:
    return n.value;

   case a.LIST:
    return n.values.map((function(e) {
      return valueFromASTUntyped(e, u);
    }));

   case a.OBJECT:
    return r(n.fields, (function(e) {
      return e.name.value;
    }), (function(e) {
      return valueFromASTUntyped(e.value, u);
    }));

   case a.VARIABLE:
    return null == u ? void 0 : u[n.name.value];
  }
  e(!1);
}

export { valueFromASTUntyped };
