"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../error/GraphQLError.js");

var r = require("../../language/printer.js");

var n = require("../../type/definition.js");

var t = require("../../utilities/typeFromAST.js");

exports.FragmentsOnCompositeTypesRule = function FragmentsOnCompositeTypesRule(o) {
  return {
    InlineFragment: function InlineFragment(i) {
      var p = i.typeCondition;
      if (p) {
        var a = t.typeFromAST(o.getSchema(), p);
        if (a && !n.isCompositeType(a)) {
          var s = r.print(p);
          o.reportError(new e.GraphQLError('Fragment cannot condition on non composite type "' + s + '".', p));
        }
      }
    },
    FragmentDefinition: function FragmentDefinition(i) {
      var p = t.typeFromAST(o.getSchema(), i.typeCondition);
      if (p && !n.isCompositeType(p)) {
        var a = r.print(i.typeCondition);
        o.reportError(new e.GraphQLError('Fragment "' + i.name.value + '" cannot condition on non composite type "' + a + '".', i.typeCondition));
      }
    }
  };
};
