import { GraphQLError as n } from "../../error/GraphQLError.mjs";

import { print as o } from "../../language/printer.mjs";

import { isCompositeType as t } from "../../type/definition.mjs";

import { typeFromAST as e } from "../../utilities/typeFromAST.mjs";

function FragmentsOnCompositeTypesRule(r) {
  return {
    InlineFragment: function InlineFragment(i) {
      var m = i.typeCondition;
      if (m) {
        var p = e(r.getSchema(), m);
        if (p && !t(p)) {
          var a = o(m);
          r.reportError(new n('Fragment cannot condition on non composite type "' + a + '".', m));
        }
      }
    },
    FragmentDefinition: function FragmentDefinition(i) {
      var m = e(r.getSchema(), i.typeCondition);
      if (m && !t(m)) {
        var p = o(i.typeCondition);
        r.reportError(new n('Fragment "' + i.name.value + '" cannot condition on non composite type "' + p + '".', i.typeCondition));
      }
    }
  };
}

export { FragmentsOnCompositeTypesRule };
