"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/didYouMean.js");

var r = require("../../jsutils/suggestionList.js");

var n = require("../../error/GraphQLError.js");

var t = require("../../language/kinds.js");

var a = require("../../type/directives.js");

function KnownArgumentNamesOnDirectivesRule(i) {
  var u = Object.create(null);
  var s = i.getSchema();
  for (var o = 0, v = s ? s.getDirectives() : a.specifiedDirectives; o < v.length; o += 1) {
    var m = v[o];
    u[m.name] = m.args.map((function(e) {
      return e.name;
    }));
  }
  for (var g = 0, c = i.getDocument().definitions; g < c.length; g += 1) {
    var l = c[g];
    if (l.kind === t.Kind.DIRECTIVE_DEFINITION) {
      var d;
      var f = null !== (d = l.arguments) && void 0 !== d ? d : [];
      u[l.name.value] = f.map((function(e) {
        return e.name.value;
      }));
    }
  }
  return {
    Directive: function Directive(t) {
      var a = t.name.value;
      var s = u[a];
      if (t.arguments && s) {
        for (var o = 0, v = t.arguments; o < v.length; o += 1) {
          var m = v[o];
          var g = m.name.value;
          if (!s.includes(g)) {
            var c = r.suggestionList(g, s);
            i.reportError(new n.GraphQLError('Unknown argument "' + g + '" on directive "@' + a + '".' + e.didYouMean(c), m));
          }
        }
      }
      return !1;
    }
  };
}

exports.KnownArgumentNamesOnDirectivesRule = KnownArgumentNamesOnDirectivesRule;

exports.KnownArgumentNamesRule = function KnownArgumentNamesRule(t) {
  return Object.assign({}, KnownArgumentNamesOnDirectivesRule(t), {
    Argument: function Argument(a) {
      var i = t.getArgument();
      var u = t.getFieldDef();
      var s = t.getParentType();
      if (!i && u && s) {
        var o = a.name.value;
        var v = u.args.map((function(e) {
          return e.name;
        }));
        var m = r.suggestionList(o, v);
        t.reportError(new n.GraphQLError('Unknown argument "' + o + '" on field "' + s.name + "." + u.name + '".' + e.didYouMean(m), a));
      }
    }
  });
};
