import { didYouMean as e } from "../../jsutils/didYouMean.mjs";

import { suggestionList as r } from "../../jsutils/suggestionList.mjs";

import { GraphQLError as n } from "../../error/GraphQLError.mjs";

import { Kind as t } from "../../language/kinds.mjs";

import { specifiedDirectives as a } from "../../type/directives.mjs";

function KnownArgumentNamesRule(t) {
  return Object.assign({}, KnownArgumentNamesOnDirectivesRule(t), {
    Argument: function Argument(a) {
      var m = t.getArgument();
      var i = t.getFieldDef();
      var u = t.getParentType();
      if (!m && i && u) {
        var o = a.name.value;
        var v = i.args.map((function(e) {
          return e.name;
        }));
        var s = r(o, v);
        t.reportError(new n('Unknown argument "' + o + '" on field "' + u.name + "." + i.name + '".' + e(s), a));
      }
    }
  });
}

function KnownArgumentNamesOnDirectivesRule(m) {
  var i = Object.create(null);
  var u = m.getSchema();
  for (var o = 0, v = u ? u.getDirectives() : a; o < v.length; o += 1) {
    var s = v[o];
    i[s.name] = s.args.map((function(e) {
      return e.name;
    }));
  }
  for (var g = 0, l = m.getDocument().definitions; g < l.length; g += 1) {
    var f = l[g];
    if (f.kind === t.DIRECTIVE_DEFINITION) {
      var c;
      var p = null !== (c = f.arguments) && void 0 !== c ? c : [];
      i[f.name.value] = p.map((function(e) {
        return e.name.value;
      }));
    }
  }
  return {
    Directive: function Directive(t) {
      var a = t.name.value;
      var u = i[a];
      if (t.arguments && u) {
        for (var o = 0, v = t.arguments; o < v.length; o += 1) {
          var s = v[o];
          var g = s.name.value;
          if (!u.includes(g)) {
            var l = r(g, u);
            m.reportError(new n('Unknown argument "' + g + '" on directive "@' + a + '".' + e(l), s));
          }
        }
      }
      return !1;
    }
  };
}

export { KnownArgumentNamesOnDirectivesRule, KnownArgumentNamesRule };
