"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/invariant.js");

var i = require("../../error/GraphQLError.js");

var r = require("../../language/kinds.js");

var n = require("../../language/directiveLocation.js");

var t = require("../../type/directives.js");

exports.KnownDirectivesRule = function KnownDirectivesRule(E) {
  var c = Object.create(null);
  var a = E.getSchema();
  for (var I = 0, N = a ? a.getDirectives() : t.specifiedDirectives; I < N.length; I += 1) {
    var o = N[I];
    c[o.name] = o.locations;
  }
  for (var T = 0, D = E.getDocument().definitions; T < D.length; T += 1) {
    var v = D[T];
    if (v.kind === r.Kind.DIRECTIVE_DEFINITION) {
      c[v.name.value] = v.locations.map((function(e) {
        return e.value;
      }));
    }
  }
  return {
    Directive: function Directive(t, a, I, N, o) {
      var T = t.name.value;
      var D = c[T];
      if (!D) {
        E.reportError(new i.GraphQLError('Unknown directive "@' + T + '".', t));
        return;
      }
      var v = function getDirectiveLocationForASTPath(i) {
        var t = i[i.length - 1];
        "kind" in t || e.invariant(!1);
        switch (t.kind) {
         case r.Kind.OPERATION_DEFINITION:
          return function getDirectiveLocationForOperation(i) {
            switch (i) {
             case "query":
              return n.DirectiveLocation.QUERY;

             case "mutation":
              return n.DirectiveLocation.MUTATION;

             case "subscription":
              return n.DirectiveLocation.SUBSCRIPTION;
            }
            e.invariant(!1);
          }(t.operation);

         case r.Kind.FIELD:
          return n.DirectiveLocation.FIELD;

         case r.Kind.FRAGMENT_SPREAD:
          return n.DirectiveLocation.FRAGMENT_SPREAD;

         case r.Kind.INLINE_FRAGMENT:
          return n.DirectiveLocation.INLINE_FRAGMENT;

         case r.Kind.FRAGMENT_DEFINITION:
          return n.DirectiveLocation.FRAGMENT_DEFINITION;

         case r.Kind.VARIABLE_DEFINITION:
          return n.DirectiveLocation.VARIABLE_DEFINITION;

         case r.Kind.SCHEMA_DEFINITION:
         case r.Kind.SCHEMA_EXTENSION:
          return n.DirectiveLocation.SCHEMA;

         case r.Kind.SCALAR_TYPE_DEFINITION:
         case r.Kind.SCALAR_TYPE_EXTENSION:
          return n.DirectiveLocation.SCALAR;

         case r.Kind.OBJECT_TYPE_DEFINITION:
         case r.Kind.OBJECT_TYPE_EXTENSION:
          return n.DirectiveLocation.OBJECT;

         case r.Kind.FIELD_DEFINITION:
          return n.DirectiveLocation.FIELD_DEFINITION;

         case r.Kind.INTERFACE_TYPE_DEFINITION:
         case r.Kind.INTERFACE_TYPE_EXTENSION:
          return n.DirectiveLocation.INTERFACE;

         case r.Kind.UNION_TYPE_DEFINITION:
         case r.Kind.UNION_TYPE_EXTENSION:
          return n.DirectiveLocation.UNION;

         case r.Kind.ENUM_TYPE_DEFINITION:
         case r.Kind.ENUM_TYPE_EXTENSION:
          return n.DirectiveLocation.ENUM;

         case r.Kind.ENUM_VALUE_DEFINITION:
          return n.DirectiveLocation.ENUM_VALUE;

         case r.Kind.INPUT_OBJECT_TYPE_DEFINITION:
         case r.Kind.INPUT_OBJECT_TYPE_EXTENSION:
          return n.DirectiveLocation.INPUT_OBJECT;

         case r.Kind.INPUT_VALUE_DEFINITION:
          var E = i[i.length - 3];
          "kind" in E || e.invariant(!1);
          return E.kind === r.Kind.INPUT_OBJECT_TYPE_DEFINITION ? n.DirectiveLocation.INPUT_FIELD_DEFINITION : n.DirectiveLocation.ARGUMENT_DEFINITION;
        }
      }(o);
      if (v && !D.includes(v)) {
        E.reportError(new i.GraphQLError('Directive "@' + T + '" may not be used on ' + v + ".", t));
      }
    }
  };
};
