import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function NoUndefinedVariablesRule(r) {
  var n = Object.create(null);
  return {
    OperationDefinition: {
      enter: function enter() {
        n = Object.create(null);
      },
      leave: function leave(a) {
        for (var i = 0, o = r.getRecursiveVariableUsages(a); i < o.length; i += 1) {
          var t = o[i].node;
          var l = t.name.value;
          if (!0 !== n[l]) {
            r.reportError(new e(a.name ? 'Variable "$' + l + '" is not defined by operation "' + a.name.value + '".' : 'Variable "$' + l + '" is not defined.', [ t, a ]));
          }
        }
      }
    },
    VariableDefinition: function VariableDefinition(e) {
      n[e.variable.name.value] = !0;
    }
  };
}

export { NoUndefinedVariablesRule };
