"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/inspect.js");

var t = require("../../error/GraphQLError.js");

var n = require("../../language/kinds.js");

var r = require("../../language/printer.js");

var a = require("../../type/definition.js");

var i = require("../../utilities/typeFromAST.js");

function reasonMessage(e) {
  if (Array.isArray(e)) {
    return e.map((function(e) {
      return 'subfields "' + e[0] + '" conflict because ' + reasonMessage(e[1]);
    })).join(" and ");
  }
  return e;
}

function collectConflictsBetweenFieldsAndFragment(e, t, n, r, a, i, l) {
  var s = e.getFragment(l);
  if (!s) {
    return;
  }
  var o = getReferencedFieldsAndFragmentNames(e, n, s);
  var c = o[0];
  var f = o[1];
  if (i === c) {
    return;
  }
  collectConflictsBetween(e, t, n, r, a, i, c);
  for (var v = 0; v < f.length; v++) {
    collectConflictsBetweenFieldsAndFragment(e, t, n, r, a, i, f[v]);
  }
}

function collectConflictsBetweenFragments(e, t, n, r, a, i, l) {
  if (i === l) {
    return;
  }
  if (r.has(i, l, a)) {
    return;
  }
  r.add(i, l, a);
  var s = e.getFragment(i);
  var o = e.getFragment(l);
  if (!s || !o) {
    return;
  }
  var c = getReferencedFieldsAndFragmentNames(e, n, s);
  var f = c[0];
  var v = c[1];
  var u = getReferencedFieldsAndFragmentNames(e, n, o);
  var d = u[1];
  collectConflictsBetween(e, t, n, r, a, f, u[0]);
  for (var g = 0; g < d.length; g++) {
    collectConflictsBetweenFragments(e, t, n, r, a, i, d[g]);
  }
  for (var p = 0; p < v.length; p++) {
    collectConflictsBetweenFragments(e, t, n, r, a, v[p], l);
  }
}

function collectConflictsBetween(e, t, n, r, a, i, l) {
  for (var s = 0, o = Object.entries(i); s < o.length; s += 1) {
    var c = o[s];
    var f = c[0];
    var v = c[1];
    var u = l[f];
    if (u) {
      for (var d = 0; d < v.length; d++) {
        for (var g = 0; g < u.length; g++) {
          var p = findConflict(e, n, r, a, f, v[d], u[g]);
          if (p) {
            t.push(p);
          }
        }
      }
    }
  }
}

function findConflict(t, n, i, l, s, o, c) {
  var f = o[0];
  var v = o[1];
  var u = o[2];
  var d = c[0];
  var g = c[1];
  var p = c[2];
  var m = l || f !== d && a.isObjectType(f) && a.isObjectType(d);
  if (!m) {
    var F, h;
    var y = v.name.value;
    var C = g.name.value;
    if (y !== C) {
      return [ [ s, '"' + y + '" and "' + C + '" are different fields' ], [ v ], [ g ] ];
    }
    if (!function sameArguments(e, t) {
      if (e.length !== t.length) {
        return !1;
      }
      return e.every((function(e) {
        var n = t.find((function(t) {
          return t.name.value === e.name.value;
        }));
        if (!n) {
          return !1;
        }
        return function sameValue(e, t) {
          return r.print(e) === r.print(t);
        }(e.value, n.value);
      }));
    }(null !== (F = v.arguments) && void 0 !== F ? F : [], null !== (h = g.arguments) && void 0 !== h ? h : [])) {
      return [ [ s, "they have differing arguments" ], [ v ], [ g ] ];
    }
  }
  var T = null == u ? void 0 : u.type;
  var A = null == p ? void 0 : p.type;
  if (T && A && doTypesConflict(T, A)) {
    return [ [ s, 'they return conflicting types "' + e.inspect(T) + '" and "' + e.inspect(A) + '"' ], [ v ], [ g ] ];
  }
  var N = v.selectionSet;
  var w = g.selectionSet;
  if (N && w) {
    return function subfieldConflicts(e, t, n, r) {
      if (e.length > 0) {
        return [ [ t, e.map((function(e) {
          return e[0];
        })) ], [ n ].concat(e.map((function(e) {
          return e[1];
        })).flat()), [ r ].concat(e.map((function(e) {
          return e[2];
        })).flat()) ];
      }
    }(function findConflictsBetweenSubSelectionSets(e, t, n, r, a, i, l, s) {
      var o = [];
      var c = getFieldsAndFragmentNames(e, t, a, i);
      var f = c[0];
      var v = c[1];
      var u = getFieldsAndFragmentNames(e, t, l, s);
      var d = u[0];
      var g = u[1];
      collectConflictsBetween(e, o, t, n, r, f, d);
      if (0 !== g.length) {
        for (var p = 0; p < g.length; p++) {
          collectConflictsBetweenFieldsAndFragment(e, o, t, n, r, f, g[p]);
        }
      }
      if (0 !== v.length) {
        for (var m = 0; m < v.length; m++) {
          collectConflictsBetweenFieldsAndFragment(e, o, t, n, r, d, v[m]);
        }
      }
      for (var F = 0; F < v.length; F++) {
        for (var h = 0; h < g.length; h++) {
          collectConflictsBetweenFragments(e, o, t, n, r, v[F], g[h]);
        }
      }
      return o;
    }(t, n, i, m, a.getNamedType(T), N, a.getNamedType(A), w), s, v, g);
  }
}

function doTypesConflict(e, t) {
  if (a.isListType(e)) {
    return a.isListType(t) ? doTypesConflict(e.ofType, t.ofType) : !0;
  }
  if (a.isListType(t)) {
    return !0;
  }
  if (a.isNonNullType(e)) {
    return a.isNonNullType(t) ? doTypesConflict(e.ofType, t.ofType) : !0;
  }
  if (a.isNonNullType(t)) {
    return !0;
  }
  if (a.isLeafType(e) || a.isLeafType(t)) {
    return e !== t;
  }
  return !1;
}

function getFieldsAndFragmentNames(e, t, n, r) {
  var a = t.get(r);
  if (a) {
    return a;
  }
  var i = Object.create(null);
  var l = Object.create(null);
  _collectFieldsAndFragmentNames(e, n, r, i, l);
  var s = [ i, Object.keys(l) ];
  t.set(r, s);
  return s;
}

function getReferencedFieldsAndFragmentNames(e, t, n) {
  var r = t.get(n.selectionSet);
  if (r) {
    return r;
  }
  var a = i.typeFromAST(e.getSchema(), n.typeCondition);
  return getFieldsAndFragmentNames(e, t, a, n.selectionSet);
}

function _collectFieldsAndFragmentNames(e, t, r, l, s) {
  for (var o = 0, c = r.selections; o < c.length; o += 1) {
    var f = c[o];
    switch (f.kind) {
     case n.Kind.FIELD:
      var v = f.name.value;
      var u = void 0;
      if (a.isObjectType(t) || a.isInterfaceType(t)) {
        u = t.getFields()[v];
      }
      var d = f.alias ? f.alias.value : v;
      if (!l[d]) {
        l[d] = [];
      }
      l[d].push([ t, f, u ]);
      break;

     case n.Kind.FRAGMENT_SPREAD:
      s[f.name.value] = !0;
      break;

     case n.Kind.INLINE_FRAGMENT:
      var g = f.typeCondition;
      var p = g ? i.typeFromAST(e.getSchema(), g) : t;
      _collectFieldsAndFragmentNames(e, p, f.selectionSet, l, s);
    }
  }
}

var l = function PairSet() {
  this._data = new Map;
};

l.prototype.has = function has(e, t, n) {
  var r;
  var a = e < t ? [ e, t ] : [ t, e ];
  var i = a[1];
  var l = null === (r = this._data.get(a[0])) || void 0 === r ? void 0 : r.get(i);
  if (void 0 === l) {
    return !1;
  }
  return n ? !0 : n === l;
};

l.prototype.add = function add(e, t, n) {
  var r = e < t ? [ e, t ] : [ t, e ];
  var a = r[0];
  var i = r[1];
  var l = this._data.get(a);
  if (void 0 === l) {
    this._data.set(a, new Map([ [ i, n ] ]));
  } else {
    l.set(i, n);
  }
};

exports.OverlappingFieldsCanBeMergedRule = function OverlappingFieldsCanBeMergedRule(e) {
  var n = new l;
  var r = new Map;
  return {
    SelectionSet: function SelectionSet(a) {
      var i = function findConflictsWithinSelectionSet(e, t, n, r, a) {
        var i = [];
        var l = getFieldsAndFragmentNames(e, t, r, a);
        var s = l[0];
        var o = l[1];
        !function collectConflictsWithin(e, t, n, r, a) {
          for (var i = 0, l = Object.entries(a); i < l.length; i += 1) {
            var s = l[i];
            var o = s[0];
            var c = s[1];
            if (c.length > 1) {
              for (var f = 0; f < c.length; f++) {
                for (var v = f + 1; v < c.length; v++) {
                  var u = findConflict(e, n, r, !1, o, c[f], c[v]);
                  if (u) {
                    t.push(u);
                  }
                }
              }
            }
          }
        }(e, i, t, n, s);
        if (0 !== o.length) {
          for (var c = 0; c < o.length; c++) {
            collectConflictsBetweenFieldsAndFragment(e, i, t, n, !1, s, o[c]);
            for (var f = c + 1; f < o.length; f++) {
              collectConflictsBetweenFragments(e, i, t, n, !1, o[c], o[f]);
            }
          }
        }
        return i;
      }(e, r, n, e.getParentType(), a);
      for (var l = 0, s = i; l < s.length; l += 1) {
        var o = s[l];
        var c = o[0];
        var f = c[0];
        var v = o[1];
        var u = o[2];
        var d = reasonMessage(c[1]);
        e.reportError(new t.GraphQLError('Fields "' + f + '" conflict because ' + d + ". Use different aliases on the fields to fetch both if this was intentional.", v.concat(u)));
      }
    }
  };
};
