"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/inspect.js");

var r = require("../../error/GraphQLError.js");

var t = require("../../type/definition.js");

var a = require("../../utilities/typeFromAST.js");

var n = require("../../utilities/typeComparators.js");

exports.PossibleFragmentSpreadsRule = function PossibleFragmentSpreadsRule(p) {
  return {
    InlineFragment: function InlineFragment(a) {
      var i = p.getType();
      var o = p.getParentType();
      if (t.isCompositeType(i) && t.isCompositeType(o) && !n.doTypesOverlap(p.getSchema(), i, o)) {
        var s = e.inspect(o);
        var v = e.inspect(i);
        p.reportError(new r.GraphQLError('Fragment cannot be spread here as objects of type "' + s + '" can never be of type "' + v + '".', a));
      }
    },
    FragmentSpread: function FragmentSpread(i) {
      var o = i.name.value;
      var s = function getFragmentType(e, r) {
        var n = e.getFragment(r);
        if (n) {
          var p = a.typeFromAST(e.getSchema(), n.typeCondition);
          if (t.isCompositeType(p)) {
            return p;
          }
        }
      }(p, o);
      var v = p.getParentType();
      if (s && v && !n.doTypesOverlap(p.getSchema(), s, v)) {
        var c = e.inspect(v);
        var m = e.inspect(s);
        p.reportError(new r.GraphQLError('Fragment "' + o + '" cannot be spread here as objects of type "' + c + '" can never be of type "' + m + '".', i));
      }
    }
  };
};
