import { inspect as e } from "../../jsutils/inspect.mjs";

import { GraphQLError as r } from "../../error/GraphQLError.mjs";

import { isCompositeType as t } from "../../type/definition.mjs";

import { typeFromAST as a } from "../../utilities/typeFromAST.mjs";

import { doTypesOverlap as n } from "../../utilities/typeComparators.mjs";

function PossibleFragmentSpreadsRule(o) {
  return {
    InlineFragment: function InlineFragment(a) {
      var m = o.getType();
      var i = o.getParentType();
      if (t(m) && t(i) && !n(o.getSchema(), m, i)) {
        var p = e(i);
        var s = e(m);
        o.reportError(new r('Fragment cannot be spread here as objects of type "' + p + '" can never be of type "' + s + '".', a));
      }
    },
    FragmentSpread: function FragmentSpread(m) {
      var i = m.name.value;
      var p = function getFragmentType(e, r) {
        var n = e.getFragment(r);
        if (n) {
          var o = a(e.getSchema(), n.typeCondition);
          if (t(o)) {
            return o;
          }
        }
      }(o, i);
      var s = o.getParentType();
      if (p && s && !n(o.getSchema(), p, s)) {
        var f = e(s);
        var g = e(p);
        o.reportError(new r('Fragment "' + i + '" cannot be spread here as objects of type "' + f + '" can never be of type "' + g + '".', m));
      }
    }
  };
}

export { PossibleFragmentSpreadsRule };
