"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/invariant.js");

var n = require("../../jsutils/didYouMean.js");

var i = require("../../jsutils/suggestionList.js");

var E = require("../../error/GraphQLError.js");

var r = require("../../language/kinds.js");

var t = require("../../language/predicates.js");

var T = require("../../type/definition.js");

var s = {};

s[r.Kind.SCALAR_TYPE_DEFINITION] = r.Kind.SCALAR_TYPE_EXTENSION;

s[r.Kind.OBJECT_TYPE_DEFINITION] = r.Kind.OBJECT_TYPE_EXTENSION;

s[r.Kind.INTERFACE_TYPE_DEFINITION] = r.Kind.INTERFACE_TYPE_EXTENSION;

s[r.Kind.UNION_TYPE_DEFINITION] = r.Kind.UNION_TYPE_EXTENSION;

s[r.Kind.ENUM_TYPE_DEFINITION] = r.Kind.ENUM_TYPE_EXTENSION;

s[r.Kind.INPUT_OBJECT_TYPE_DEFINITION] = r.Kind.INPUT_OBJECT_TYPE_EXTENSION;

exports.PossibleTypeExtensionsRule = function PossibleTypeExtensionsRule(N) {
  var a = N.getSchema();
  var o = Object.create(null);
  for (var _ = 0, u = N.getDocument().definitions; _ < u.length; _ += 1) {
    var I = u[_];
    if (t.isTypeDefinitionNode(I)) {
      o[I.name.value] = I;
    }
  }
  return {
    ScalarTypeExtension: checkExtension,
    ObjectTypeExtension: checkExtension,
    InterfaceTypeExtension: checkExtension,
    UnionTypeExtension: checkExtension,
    EnumTypeExtension: checkExtension,
    InputObjectTypeExtension: checkExtension
  };
  function checkExtension(t) {
    var _ = t.name.value;
    var u = o[_];
    var I = null == a ? void 0 : a.getType(_);
    var c;
    if (u) {
      c = s[u.kind];
    } else if (I) {
      c = function typeToExtKind(n) {
        if (T.isScalarType(n)) {
          return r.Kind.SCALAR_TYPE_EXTENSION;
        }
        if (T.isObjectType(n)) {
          return r.Kind.OBJECT_TYPE_EXTENSION;
        }
        if (T.isInterfaceType(n)) {
          return r.Kind.INTERFACE_TYPE_EXTENSION;
        }
        if (T.isUnionType(n)) {
          return r.Kind.UNION_TYPE_EXTENSION;
        }
        if (T.isEnumType(n)) {
          return r.Kind.ENUM_TYPE_EXTENSION;
        }
        if (T.isInputObjectType(n)) {
          return r.Kind.INPUT_OBJECT_TYPE_EXTENSION;
        }
        e.invariant(!1);
      }(I);
    }
    if (c) {
      if (c !== t.kind) {
        var d = function extensionKindToTypeName(n) {
          switch (n) {
           case r.Kind.SCALAR_TYPE_EXTENSION:
            return "scalar";

           case r.Kind.OBJECT_TYPE_EXTENSION:
            return "object";

           case r.Kind.INTERFACE_TYPE_EXTENSION:
            return "interface";

           case r.Kind.UNION_TYPE_EXTENSION:
            return "union";

           case r.Kind.ENUM_TYPE_EXTENSION:
            return "enum";

           case r.Kind.INPUT_OBJECT_TYPE_EXTENSION:
            return "input object";
          }
          e.invariant(!1);
        }(t.kind);
        N.reportError(new E.GraphQLError("Cannot extend non-" + d + ' type "' + _ + '".', u ? [ u, t ] : t));
      }
    } else {
      var O = Object.keys(Object.assign({}, o, null == a ? void 0 : a.getTypeMap()));
      var p = i.suggestionList(_, O);
      N.reportError(new E.GraphQLError('Cannot extend type "' + _ + '" because it is not defined.' + n.didYouMean(p), t.name));
    }
  }
};
