"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/inspect.js");

var r = require("../../jsutils/keyMap.js");

var i = require("../../error/GraphQLError.js");

var t = require("../../language/kinds.js");

var n = require("../../language/printer.js");

var u = require("../../type/directives.js");

var a = require("../../type/definition.js");

function ProvidedRequiredArgumentsOnDirectivesRule(v) {
  var s;
  var d = Object.create(null);
  var o = v.getSchema();
  for (var l = 0, p = null !== (s = null == o ? void 0 : o.getDirectives()) && void 0 !== s ? s : u.specifiedDirectives; l < p.length; l += 1) {
    var c = p[l];
    d[c.name] = r.keyMap(c.args.filter(a.isRequiredArgument), (function(e) {
      return e.name;
    }));
  }
  for (var g = 0, m = v.getDocument().definitions; g < m.length; g += 1) {
    var f = m[g];
    if (f.kind === t.Kind.DIRECTIVE_DEFINITION) {
      var q;
      var R = null !== (q = f.arguments) && void 0 !== q ? q : [];
      d[f.name.value] = r.keyMap(R.filter(isRequiredArgumentNode), (function(e) {
        return e.name.value;
      }));
    }
  }
  return {
    Directive: {
      leave: function leave(r) {
        var t = r.name.value;
        var u = d[t];
        if (u) {
          var s;
          var o = null !== (s = r.arguments) && void 0 !== s ? s : [];
          var l = new Set(o.map((function(e) {
            return e.name.value;
          })));
          for (var p = 0, c = Object.entries(u); p < c.length; p += 1) {
            var g = c[p];
            var m = g[0];
            var f = g[1];
            if (!l.has(m)) {
              var q = a.isType(f.type) ? e.inspect(f.type) : n.print(f.type);
              v.reportError(new i.GraphQLError('Directive "@' + t + '" argument "' + m + '" of type "' + q + '" is required, but it was not provided.', r));
            }
          }
        }
      }
    }
  };
}

function isRequiredArgumentNode(e) {
  return e.type.kind === t.Kind.NON_NULL_TYPE && null == e.defaultValue;
}

exports.ProvidedRequiredArgumentsOnDirectivesRule = ProvidedRequiredArgumentsOnDirectivesRule;

exports.ProvidedRequiredArgumentsRule = function ProvidedRequiredArgumentsRule(r) {
  return Object.assign({}, ProvidedRequiredArgumentsOnDirectivesRule(r), {
    Field: {
      leave: function leave(t) {
        var n;
        var u = r.getFieldDef();
        if (!u) {
          return !1;
        }
        var v = new Set(null === (n = t.arguments) || void 0 === n ? void 0 : n.map((function(e) {
          return e.name.value;
        })));
        for (var s = 0, d = u.args; s < d.length; s += 1) {
          var o = d[s];
          if (!v.has(o.name) && a.isRequiredArgument(o)) {
            var l = e.inspect(o.type);
            r.reportError(new i.GraphQLError('Field "' + u.name + '" argument "' + o.name + '" of type "' + l + '" is required, but it was not provided.', t));
          }
        }
      }
    }
  });
};
