import { inspect as e } from "../../jsutils/inspect.mjs";

import { keyMap as r } from "../../jsutils/keyMap.mjs";

import { GraphQLError as t } from "../../error/GraphQLError.mjs";

import { Kind as i } from "../../language/kinds.mjs";

import { print as n } from "../../language/printer.mjs";

import { specifiedDirectives as a } from "../../type/directives.mjs";

import { isType as u, isRequiredArgument as o } from "../../type/definition.mjs";

function ProvidedRequiredArgumentsRule(r) {
  return Object.assign({}, ProvidedRequiredArgumentsOnDirectivesRule(r), {
    Field: {
      leave: function leave(i) {
        var n;
        var a = r.getFieldDef();
        if (!a) {
          return !1;
        }
        var u = new Set(null === (n = i.arguments) || void 0 === n ? void 0 : n.map((function(e) {
          return e.name.value;
        })));
        for (var v = 0, m = a.args; v < m.length; v += 1) {
          var l = m[v];
          if (!u.has(l.name) && o(l)) {
            var d = e(l.type);
            r.reportError(new t('Field "' + a.name + '" argument "' + l.name + '" of type "' + d + '" is required, but it was not provided.', i));
          }
        }
      }
    }
  });
}

function ProvidedRequiredArgumentsOnDirectivesRule(v) {
  var m;
  var l = Object.create(null);
  var d = v.getSchema();
  for (var s = 0, f = null !== (m = null == d ? void 0 : d.getDirectives()) && void 0 !== m ? m : a; s < f.length; s += 1) {
    var g = f[s];
    l[g.name] = r(g.args.filter(o), (function(e) {
      return e.name;
    }));
  }
  for (var p = 0, c = v.getDocument().definitions; p < c.length; p += 1) {
    var R = c[p];
    if (R.kind === i.DIRECTIVE_DEFINITION) {
      var j;
      var y = null !== (j = R.arguments) && void 0 !== j ? j : [];
      l[R.name.value] = r(y.filter(isRequiredArgumentNode), (function(e) {
        return e.name.value;
      }));
    }
  }
  return {
    Directive: {
      leave: function leave(r) {
        var i = r.name.value;
        var a = l[i];
        if (a) {
          var o;
          var m = null !== (o = r.arguments) && void 0 !== o ? o : [];
          var d = new Set(m.map((function(e) {
            return e.name.value;
          })));
          for (var s = 0, f = Object.entries(a); s < f.length; s += 1) {
            var g = f[s];
            var p = g[0];
            var c = g[1];
            if (!d.has(p)) {
              var R = u(c.type) ? e(c.type) : n(c.type);
              v.reportError(new t('Directive "@' + i + '" argument "' + p + '" of type "' + R + '" is required, but it was not provided.', r));
            }
          }
        }
      }
    }
  };
}

function isRequiredArgumentNode(e) {
  return e.type.kind === i.NON_NULL_TYPE && null == e.defaultValue;
}

export { ProvidedRequiredArgumentsOnDirectivesRule, ProvidedRequiredArgumentsRule };
