import { inspect as e } from "../../jsutils/inspect.mjs";

import { GraphQLError as r } from "../../error/GraphQLError.mjs";

import { isLeafType as i, getNamedType as o } from "../../type/definition.mjs";

function ScalarLeafsRule(a) {
  return {
    Field: function Field(t) {
      var s = a.getType();
      var n = t.selectionSet;
      if (s) {
        if (i(o(s))) {
          if (n) {
            var l = t.name.value;
            var f = e(s);
            a.reportError(new r('Field "' + l + '" must not have a selection since type "' + f + '" has no subfields.', n));
          }
        } else if (!n) {
          var m = t.name.value;
          var u = e(s);
          a.reportError(new r('Field "' + m + '" of type "' + u + '" must have a selection of subfields. Did you mean "' + m + ' { ... }"?', t));
        }
      }
    }
  };
}

export { ScalarLeafsRule };
