import { GraphQLError as e } from "../../error/GraphQLError.mjs";

import { Kind as n } from "../../language/kinds.mjs";

import { collectFields as t } from "../../execution/collectFields.mjs";

function SingleFieldSubscriptionsRule(i) {
  return {
    OperationDefinition: function OperationDefinition(r) {
      if ("subscription" === r.operation) {
        var o = i.getSchema();
        var l = o.getSubscriptionType();
        if (l) {
          var a = r.name ? r.name.value : null;
          var s = Object.create(null);
          var u = i.getDocument();
          var c = Object.create(null);
          for (var p = 0, v = u.definitions; p < v.length; p += 1) {
            var m = v[p];
            if (m.kind === n.FRAGMENT_DEFINITION) {
              c[m.name.value] = m;
            }
          }
          var f = t(o, c, s, l, r.selectionSet, new Map, new Set);
          if (f.size > 1) {
            var S = [].concat(f.values()).slice(1).flat();
            i.reportError(new e(null != a ? 'Subscription "' + a + '" must select only one top level field.' : "Anonymous Subscription must select only one top level field.", S));
          }
          for (var b = 0, d = f.values(); b < d.length; b += 1) {
            var g = d[b];
            var j = g[0].name.value;
            if ("_" === j[0] && "_" === j[1]) {
              i.reportError(new e(null != a ? 'Subscription "' + a + '" must not select an introspection top level field.' : "Anonymous Subscription must not select an introspection top level field.", g));
            }
          }
        }
      }
    }
  };
}

export { SingleFieldSubscriptionsRule };
