import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueArgumentNamesRule(r) {
  var n = Object.create(null);
  return {
    Field: function Field() {
      n = Object.create(null);
    },
    Directive: function Directive() {
      n = Object.create(null);
    },
    Argument: function Argument(t) {
      var u = t.name.value;
      if (n[u]) {
        r.reportError(new e('There can be only one argument named "' + u + '".', [ n[u], t.name ]));
      } else {
        n[u] = t.name;
      }
      return !1;
    }
  };
}

export { UniqueArgumentNamesRule };
