import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueDirectiveNamesRule(r) {
  var i = Object.create(null);
  var n = r.getSchema();
  return {
    DirectiveDefinition: function DirectiveDefinition(t) {
      var a = t.name.value;
      if (null != n && n.getDirective(a)) {
        r.reportError(new e('Directive "@' + a + '" already exists in the schema. It cannot be redefined.', t.name));
        return;
      }
      if (i[a]) {
        r.reportError(new e('There can be only one directive named "@' + a + '".', [ i[a], t.name ]));
      } else {
        i[a] = t.name;
      }
      return !1;
    }
  };
}

export { UniqueDirectiveNamesRule };
