"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../error/GraphQLError.js");

var r = require("../../language/kinds.js");

var i = require("../../language/predicates.js");

var t = require("../../type/directives.js");

exports.UniqueDirectivesPerLocationRule = function UniqueDirectivesPerLocationRule(a) {
  var n = Object.create(null);
  var c = a.getSchema();
  for (var v = 0, s = c ? c.getDirectives() : t.specifiedDirectives; v < s.length; v += 1) {
    var l = s[v];
    n[l.name] = !l.isRepeatable;
  }
  for (var o = 0, u = a.getDocument().definitions; o < u.length; o += 1) {
    var d = u[o];
    if (d.kind === r.Kind.DIRECTIVE_DEFINITION) {
      n[d.name.value] = !d.repeatable;
    }
  }
  var f = Object.create(null);
  var p = Object.create(null);
  return {
    enter: function enter(t) {
      if (!("directives" in t) || !t.directives) {
        return;
      }
      var c;
      if (t.kind === r.Kind.SCHEMA_DEFINITION || t.kind === r.Kind.SCHEMA_EXTENSION) {
        c = f;
      } else if (i.isTypeDefinitionNode(t) || i.isTypeExtensionNode(t)) {
        var v = t.name.value;
        if (void 0 === (c = p[v])) {
          p[v] = c = Object.create(null);
        }
      } else {
        c = Object.create(null);
      }
      for (var s = 0, l = t.directives; s < l.length; s += 1) {
        var o = l[s];
        var u = o.name.value;
        if (n[u]) {
          if (c[u]) {
            a.reportError(new e.GraphQLError('The directive "@' + u + '" can only be used once at this location.', [ c[u], o ]));
          } else {
            c[u] = o;
          }
        }
      }
    }
  };
};
