import { GraphQLError as e } from "../../error/GraphQLError.mjs";

import { Kind as r } from "../../language/kinds.mjs";

import { isTypeDefinitionNode as t, isTypeExtensionNode as i } from "../../language/predicates.mjs";

import { specifiedDirectives as a } from "../../type/directives.mjs";

function UniqueDirectivesPerLocationRule(n) {
  var o = Object.create(null);
  var c = n.getSchema();
  for (var l = 0, v = c ? c.getDirectives() : a; l < v.length; l += 1) {
    var s = v[l];
    o[s.name] = !s.isRepeatable;
  }
  for (var u = 0, m = n.getDocument().definitions; u < m.length; u += 1) {
    var f = m[u];
    if (f.kind === r.DIRECTIVE_DEFINITION) {
      o[f.name.value] = !f.repeatable;
    }
  }
  var d = Object.create(null);
  var p = Object.create(null);
  return {
    enter: function enter(a) {
      if (!("directives" in a) || !a.directives) {
        return;
      }
      var c;
      if (a.kind === r.SCHEMA_DEFINITION || a.kind === r.SCHEMA_EXTENSION) {
        c = d;
      } else if (t(a) || i(a)) {
        var l = a.name.value;
        if (void 0 === (c = p[l])) {
          p[l] = c = Object.create(null);
        }
      } else {
        c = Object.create(null);
      }
      for (var v = 0, s = a.directives; v < s.length; v += 1) {
        var u = s[v];
        var m = u.name.value;
        if (o[m]) {
          if (c[m]) {
            n.reportError(new e('The directive "@' + m + '" can only be used once at this location.', [ c[m], u ]));
          } else {
            c[m] = u;
          }
        }
      }
    }
  };
}

export { UniqueDirectivesPerLocationRule };
