import { GraphQLError as e } from "../../error/GraphQLError.mjs";

import { isEnumType as n } from "../../type/definition.mjs";

function UniqueEnumValueNamesRule(r) {
  var a = r.getSchema();
  var u = a ? a.getTypeMap() : Object.create(null);
  var t = Object.create(null);
  return {
    EnumTypeDefinition: checkValueUniqueness,
    EnumTypeExtension: checkValueUniqueness
  };
  function checkValueUniqueness(a) {
    var i;
    var l = a.name.value;
    if (!t[l]) {
      t[l] = Object.create(null);
    }
    var o = null !== (i = a.values) && void 0 !== i ? i : [];
    var m = t[l];
    for (var s = 0, c = o; s < c.length; s += 1) {
      var v = c[s];
      var f = v.name.value;
      var p = u[l];
      if (n(p) && p.getValue(f)) {
        r.reportError(new e('Enum value "' + l + "." + f + '" already exists in the schema. It cannot also be defined in this type extension.', v.name));
      } else if (m[f]) {
        r.reportError(new e('Enum value "' + l + "." + f + '" can only be defined once.', [ m[f], v.name ]));
      } else {
        m[f] = v.name;
      }
    }
    return !1;
  }
}

export { UniqueEnumValueNamesRule };
