"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../error/GraphQLError.js");

var n = require("../../type/definition.js");

function hasField(e, i) {
  if (n.isObjectType(e) || n.isInterfaceType(e) || n.isInputObjectType(e)) {
    return null != e.getFields()[i];
  }
  return !1;
}

exports.UniqueFieldDefinitionNamesRule = function UniqueFieldDefinitionNamesRule(n) {
  var i = n.getSchema();
  var r = i ? i.getTypeMap() : Object.create(null);
  var t = Object.create(null);
  return {
    InputObjectTypeDefinition: checkFieldUniqueness,
    InputObjectTypeExtension: checkFieldUniqueness,
    InterfaceTypeDefinition: checkFieldUniqueness,
    InterfaceTypeExtension: checkFieldUniqueness,
    ObjectTypeDefinition: checkFieldUniqueness,
    ObjectTypeExtension: checkFieldUniqueness
  };
  function checkFieldUniqueness(i) {
    var a;
    var s = i.name.value;
    if (!t[s]) {
      t[s] = Object.create(null);
    }
    var c = null !== (a = i.fields) && void 0 !== a ? a : [];
    var l = t[s];
    for (var u = 0, o = c; u < o.length; u += 1) {
      var d = o[u];
      var p = d.name.value;
      if (hasField(r[s], p)) {
        n.reportError(new e.GraphQLError('Field "' + s + "." + p + '" already exists in the schema. It cannot also be defined in this type extension.', d.name));
      } else if (l[p]) {
        n.reportError(new e.GraphQLError('Field "' + s + "." + p + '" can only be defined once.', [ l[p], d.name ]));
      } else {
        l[p] = d.name;
      }
    }
    return !1;
  }
};
