import { GraphQLError as e } from "../../error/GraphQLError.mjs";

import { isObjectType as n, isInterfaceType as i, isInputObjectType as r } from "../../type/definition.mjs";

function UniqueFieldDefinitionNamesRule(n) {
  var i = n.getSchema();
  var r = i ? i.getTypeMap() : Object.create(null);
  var t = Object.create(null);
  return {
    InputObjectTypeDefinition: checkFieldUniqueness,
    InputObjectTypeExtension: checkFieldUniqueness,
    InterfaceTypeDefinition: checkFieldUniqueness,
    InterfaceTypeExtension: checkFieldUniqueness,
    ObjectTypeDefinition: checkFieldUniqueness,
    ObjectTypeExtension: checkFieldUniqueness
  };
  function checkFieldUniqueness(i) {
    var a;
    var l = i.name.value;
    if (!t[l]) {
      t[l] = Object.create(null);
    }
    var c = null !== (a = i.fields) && void 0 !== a ? a : [];
    var s = t[l];
    for (var o = 0, u = c; o < u.length; o += 1) {
      var d = u[o];
      var f = d.name.value;
      if (hasField(r[l], f)) {
        n.reportError(new e('Field "' + l + "." + f + '" already exists in the schema. It cannot also be defined in this type extension.', d.name));
      } else if (s[f]) {
        n.reportError(new e('Field "' + l + "." + f + '" can only be defined once.', [ s[f], d.name ]));
      } else {
        s[f] = d.name;
      }
    }
    return !1;
  }
}

function hasField(e, t) {
  if (n(e) || i(e) || r(e)) {
    return null != e.getFields()[t];
  }
  return !1;
}

export { UniqueFieldDefinitionNamesRule };
