import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueFragmentNamesRule(n) {
  var r = Object.create(null);
  return {
    OperationDefinition: function() {
      return !1;
    },
    FragmentDefinition: function FragmentDefinition(t) {
      var a = t.name.value;
      if (r[a]) {
        n.reportError(new e('There can be only one fragment named "' + a + '".', [ r[a], t.name ]));
      } else {
        r[a] = t.name;
      }
      return !1;
    }
  };
}

export { UniqueFragmentNamesRule };
