import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueOperationNamesRule(r) {
  var n = Object.create(null);
  return {
    OperationDefinition: function OperationDefinition(i) {
      var o = i.name;
      if (o) {
        if (n[o.value]) {
          r.reportError(new e('There can be only one operation named "' + o.value + '".', [ n[o.value], o ]));
        } else {
          n[o.value] = o;
        }
      }
      return !1;
    },
    FragmentDefinition: function() {
      return !1;
    }
  };
}

export { UniqueOperationNamesRule };
