import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueOperationTypesRule(r) {
  var n = r.getSchema();
  var t = Object.create(null);
  var o = n ? {
    query: n.getQueryType(),
    mutation: n.getMutationType(),
    subscription: n.getSubscriptionType()
  } : {};
  return {
    SchemaDefinition: checkOperationTypes,
    SchemaExtension: checkOperationTypes
  };
  function checkOperationTypes(n) {
    var i;
    for (var a = 0, p = null !== (i = n.operationTypes) && void 0 !== i ? i : []; a < p.length; a += 1) {
      var c = p[a];
      var u = c.operation;
      var s = t[u];
      if (o[u]) {
        r.reportError(new e("Type for " + u + " already defined in the schema. It cannot be redefined.", c));
      } else if (s) {
        r.reportError(new e("There can be only one " + u + " type in schema.", [ s, c ]));
      } else {
        t[u] = c;
      }
    }
    return !1;
  }
}

export { UniqueOperationTypesRule };
