"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../error/GraphQLError.js");

exports.UniqueTypeNamesRule = function UniqueTypeNamesRule(r) {
  var n = Object.create(null);
  var i = r.getSchema();
  return {
    ScalarTypeDefinition: checkTypeName,
    ObjectTypeDefinition: checkTypeName,
    InterfaceTypeDefinition: checkTypeName,
    UnionTypeDefinition: checkTypeName,
    EnumTypeDefinition: checkTypeName,
    InputObjectTypeDefinition: checkTypeName
  };
  function checkTypeName(t) {
    var a = t.name.value;
    if (null != i && i.getType(a)) {
      r.reportError(new e.GraphQLError('Type "' + a + '" already exists in the schema. It cannot also be defined in this type definition.', t.name));
      return;
    }
    if (n[a]) {
      r.reportError(new e.GraphQLError('There can be only one type named "' + a + '".', [ n[a], t.name ]));
    } else {
      n[a] = t.name;
    }
    return !1;
  }
};
