import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueTypeNamesRule(n) {
  var i = Object.create(null);
  var r = n.getSchema();
  return {
    ScalarTypeDefinition: checkTypeName,
    ObjectTypeDefinition: checkTypeName,
    InterfaceTypeDefinition: checkTypeName,
    UnionTypeDefinition: checkTypeName,
    EnumTypeDefinition: checkTypeName,
    InputObjectTypeDefinition: checkTypeName
  };
  function checkTypeName(t) {
    var a = t.name.value;
    if (null != r && r.getType(a)) {
      n.reportError(new e('Type "' + a + '" already exists in the schema. It cannot also be defined in this type definition.', t.name));
      return;
    }
    if (i[a]) {
      n.reportError(new e('There can be only one type named "' + a + '".', [ i[a], t.name ]));
    } else {
      i[a] = t.name;
    }
    return !1;
  }
}

export { UniqueTypeNamesRule };
