import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueVariableNamesRule(r) {
  var a = Object.create(null);
  return {
    OperationDefinition: function OperationDefinition() {
      a = Object.create(null);
    },
    VariableDefinition: function VariableDefinition(i) {
      var n = i.variable.name.value;
      if (a[n]) {
        r.reportError(new e('There can be only one variable named "$' + n + '".', [ a[n], i.variable.name ]));
      } else {
        a[n] = i.variable.name;
      }
    }
  };
}

export { UniqueVariableNamesRule };
