"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/keyMap.js");

var r = require("../../jsutils/inspect.js");

var t = require("../../jsutils/didYouMean.js");

var i = require("../../jsutils/suggestionList.js");

var a = require("../../error/GraphQLError.js");

var n = require("../../language/printer.js");

var u = require("../../type/definition.js");

function isValidValueNode(e, t) {
  var i = e.getInputType();
  if (!i) {
    return;
  }
  var o = u.getNamedType(i);
  if (!u.isLeafType(o)) {
    var p = r.inspect(i);
    e.reportError(new a.GraphQLError('Expected value of type "' + p + '", found ' + n.print(t) + ".", t));
    return;
  }
  try {
    if (void 0 === o.parseLiteral(t, void 0)) {
      var l = r.inspect(i);
      e.reportError(new a.GraphQLError('Expected value of type "' + l + '", found ' + n.print(t) + ".", t));
    }
  } catch (u) {
    var s = r.inspect(i);
    if (u instanceof a.GraphQLError) {
      e.reportError(u);
    } else {
      e.reportError(new a.GraphQLError('Expected value of type "' + s + '", found ' + n.print(t) + "; " + u.message, t, void 0, void 0, void 0, u));
    }
  }
}

exports.ValuesOfCorrectTypeRule = function ValuesOfCorrectTypeRule(o) {
  return {
    ListValue: function ListValue(e) {
      var r = u.getNullableType(o.getParentInputType());
      if (!u.isListType(r)) {
        isValidValueNode(o, e);
        return !1;
      }
    },
    ObjectValue: function ObjectValue(t) {
      var i = u.getNamedType(o.getInputType());
      if (!u.isInputObjectType(i)) {
        isValidValueNode(o, t);
        return !1;
      }
      var n = e.keyMap(t.fields, (function(e) {
        return e.name.value;
      }));
      for (var p = 0, l = Object.values(i.getFields()); p < l.length; p += 1) {
        var s = l[p];
        if (!n[s.name] && u.isRequiredInputField(s)) {
          var d = r.inspect(s.type);
          o.reportError(new a.GraphQLError('Field "' + i.name + "." + s.name + '" of required type "' + d + '" was not provided.', t));
        }
      }
    },
    ObjectField: function ObjectField(e) {
      var r = u.getNamedType(o.getParentInputType());
      if (!o.getInputType() && u.isInputObjectType(r)) {
        var n = i.suggestionList(e.name.value, Object.keys(r.getFields()));
        o.reportError(new a.GraphQLError('Field "' + e.name.value + '" is not defined by type "' + r.name + '".' + t.didYouMean(n), e));
      }
    },
    NullValue: function NullValue(e) {
      var t = o.getInputType();
      if (u.isNonNullType(t)) {
        o.reportError(new a.GraphQLError('Expected value of type "' + r.inspect(t) + '", found ' + n.print(e) + ".", e));
      }
    },
    EnumValue: function(e) {
      return isValidValueNode(o, e);
    },
    IntValue: function(e) {
      return isValidValueNode(o, e);
    },
    FloatValue: function(e) {
      return isValidValueNode(o, e);
    },
    StringValue: function(e) {
      return isValidValueNode(o, e);
    },
    BooleanValue: function(e) {
      return isValidValueNode(o, e);
    }
  };
};
