import { keyMap as e } from "../../jsutils/keyMap.mjs";

import { inspect as r } from "../../jsutils/inspect.mjs";

import { didYouMean as t } from "../../jsutils/didYouMean.mjs";

import { suggestionList as o } from "../../jsutils/suggestionList.mjs";

import { GraphQLError as i } from "../../error/GraphQLError.mjs";

import { print as n } from "../../language/printer.mjs";

import { getNullableType as u, isListType as a, getNamedType as l, isInputObjectType as p, isRequiredInputField as d, isNonNullType as f, isLeafType as s } from "../../type/definition.mjs";

function ValuesOfCorrectTypeRule(s) {
  return {
    ListValue: function ListValue(e) {
      var r = u(s.getParentInputType());
      if (!a(r)) {
        isValidValueNode(s, e);
        return !1;
      }
    },
    ObjectValue: function ObjectValue(t) {
      var o = l(s.getInputType());
      if (!p(o)) {
        isValidValueNode(s, t);
        return !1;
      }
      var n = e(t.fields, (function(e) {
        return e.name.value;
      }));
      for (var u = 0, a = Object.values(o.getFields()); u < a.length; u += 1) {
        var f = a[u];
        if (!n[f.name] && d(f)) {
          var m = r(f.type);
          s.reportError(new i('Field "' + o.name + "." + f.name + '" of required type "' + m + '" was not provided.', t));
        }
      }
    },
    ObjectField: function ObjectField(e) {
      var r = l(s.getParentInputType());
      if (!s.getInputType() && p(r)) {
        var n = o(e.name.value, Object.keys(r.getFields()));
        s.reportError(new i('Field "' + e.name.value + '" is not defined by type "' + r.name + '".' + t(n), e));
      }
    },
    NullValue: function NullValue(e) {
      var t = s.getInputType();
      if (f(t)) {
        s.reportError(new i('Expected value of type "' + r(t) + '", found ' + n(e) + ".", e));
      }
    },
    EnumValue: function(e) {
      return isValidValueNode(s, e);
    },
    IntValue: function(e) {
      return isValidValueNode(s, e);
    },
    FloatValue: function(e) {
      return isValidValueNode(s, e);
    },
    StringValue: function(e) {
      return isValidValueNode(s, e);
    },
    BooleanValue: function(e) {
      return isValidValueNode(s, e);
    }
  };
}

function isValidValueNode(e, t) {
  var o = e.getInputType();
  if (!o) {
    return;
  }
  var u = l(o);
  if (!s(u)) {
    var a = r(o);
    e.reportError(new i('Expected value of type "' + a + '", found ' + n(t) + ".", t));
    return;
  }
  try {
    if (void 0 === u.parseLiteral(t, void 0)) {
      var p = r(o);
      e.reportError(new i('Expected value of type "' + p + '", found ' + n(t) + ".", t));
    }
  } catch (u) {
    var d = r(o);
    if (u instanceof i) {
      e.reportError(u);
    } else {
      e.reportError(new i('Expected value of type "' + d + '", found ' + n(t) + "; " + u.message, t, void 0, void 0, void 0, u));
    }
  }
}

export { ValuesOfCorrectTypeRule };
