import { GraphQLError as r } from "../../error/GraphQLError.mjs";

import { print as e } from "../../language/printer.mjs";

import { isInputType as i } from "../../type/definition.mjs";

import { typeFromAST as t } from "../../utilities/typeFromAST.mjs";

function VariablesAreInputTypesRule(a) {
  return {
    VariableDefinition: function VariableDefinition(n) {
      var o = t(a.getSchema(), n.type);
      if (o && !i(o)) {
        var p = n.variable.name.value;
        var m = e(n.type);
        a.reportError(new r('Variable "$' + p + '" cannot be non-input type "' + m + '".', n.type));
      }
    }
  };
}

export { VariablesAreInputTypesRule };
