"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/inspect.js");

var r = require("../../error/GraphQLError.js");

var i = require("../../language/kinds.js");

var a = require("../../type/definition.js");

var t = require("../../utilities/typeFromAST.js");

var n = require("../../utilities/typeComparators.js");

function allowedVariableUsage(e, r, t, l, o) {
  if (a.isNonNullType(l) && !a.isNonNullType(r)) {
    if (!(null != t && t.kind !== i.Kind.NULL) && !(void 0 !== o)) {
      return !1;
    }
    return n.isTypeSubTypeOf(e, r, l.ofType);
  }
  return n.isTypeSubTypeOf(e, r, l);
}

exports.VariablesInAllowedPositionRule = function VariablesInAllowedPositionRule(i) {
  var a = Object.create(null);
  return {
    OperationDefinition: {
      enter: function enter() {
        a = Object.create(null);
      },
      leave: function leave(n) {
        for (var l = 0, o = i.getRecursiveVariableUsages(n); l < o.length; l += 1) {
          var u = o[l];
          var s = u.node;
          var p = u.type;
          var v = u.defaultValue;
          var f = s.name.value;
          var c = a[f];
          if (c && p) {
            var y = i.getSchema();
            var d = t.typeFromAST(y, c.type);
            if (d && !allowedVariableUsage(y, d, c.defaultValue, p, v)) {
              var b = e.inspect(d);
              var j = e.inspect(p);
              i.reportError(new r.GraphQLError('Variable "$' + f + '" of type "' + b + '" used in position expecting type "' + j + '".', [ c, s ]));
            }
          }
        }
      }
    },
    VariableDefinition: function VariableDefinition(e) {
      a[e.variable.name.value] = e;
    }
  };
};
