import { inspect as e } from "../../jsutils/inspect.mjs";

import { GraphQLError as r } from "../../error/GraphQLError.mjs";

import { Kind as i } from "../../language/kinds.mjs";

import { isNonNullType as a } from "../../type/definition.mjs";

import { typeFromAST as t } from "../../utilities/typeFromAST.mjs";

import { isTypeSubTypeOf as o } from "../../utilities/typeComparators.mjs";

function VariablesInAllowedPositionRule(i) {
  var a = Object.create(null);
  return {
    OperationDefinition: {
      enter: function enter() {
        a = Object.create(null);
      },
      leave: function leave(o) {
        for (var n = 0, l = i.getRecursiveVariableUsages(o); n < l.length; n += 1) {
          var u = l[n];
          var f = u.node;
          var s = u.type;
          var m = u.defaultValue;
          var p = f.name.value;
          var v = a[p];
          if (v && s) {
            var c = i.getSchema();
            var d = t(c, v.type);
            if (d && !allowedVariableUsage(c, d, v.defaultValue, s, m)) {
              var b = e(d);
              var V = e(s);
              i.reportError(new r('Variable "$' + p + '" of type "' + b + '" used in position expecting type "' + V + '".', [ v, f ]));
            }
          }
        }
      }
    },
    VariableDefinition: function VariableDefinition(e) {
      a[e.variable.name.value] = e;
    }
  };
}

function allowedVariableUsage(e, r, t, n, l) {
  if (a(n) && !a(r)) {
    if (!(null != t && t.kind !== i.NULL) && !(void 0 !== l)) {
      return !1;
    }
    return o(e, r, n.ofType);
  }
  return o(e, r, n);
}

export { VariablesInAllowedPositionRule };
