import { invariant as e } from "../../../jsutils/invariant.mjs";

import { GraphQLError as r } from "../../../error/GraphQLError.mjs";

import { getNamedType as n, isInputObjectType as t } from "../../../type/definition.mjs";

function NoDeprecatedCustomRule(a) {
  return {
    Field: function Field(n) {
      var t = a.getFieldDef();
      var i = null == t ? void 0 : t.deprecationReason;
      if (t && null != i) {
        var l = a.getParentType();
        null != l || e(!1);
        a.reportError(new r("The field " + l.name + "." + t.name + " is deprecated. " + i, n));
      }
    },
    Argument: function Argument(n) {
      var t = a.getArgument();
      var i = null == t ? void 0 : t.deprecationReason;
      if (t && null != i) {
        var l = a.getDirective();
        if (null != l) {
          a.reportError(new r('Directive "@' + l.name + '" argument "' + t.name + '" is deprecated. ' + i, n));
        } else {
          var o = a.getParentType();
          var u = a.getFieldDef();
          null != o && null != u || e(!1);
          a.reportError(new r('Field "' + o.name + "." + u.name + '" argument "' + t.name + '" is deprecated. ' + i, n));
        }
      }
    },
    ObjectField: function ObjectField(e) {
      var i = n(a.getParentInputType());
      if (t(i)) {
        var l = i.getFields()[e.name.value];
        var o = null == l ? void 0 : l.deprecationReason;
        if (null != o) {
          a.reportError(new r("The input field " + i.name + "." + l.name + " is deprecated. " + o, e));
        }
      }
    },
    EnumValue: function EnumValue(t) {
      var i = a.getEnumValue();
      var l = null == i ? void 0 : i.deprecationReason;
      if (i && null != l) {
        var o = n(a.getInputType());
        null != o || e(!1);
        a.reportError(new r('The enum value "' + o.name + "." + i.name + '" is deprecated. ' + l, t));
      }
    }
  };
}

export { NoDeprecatedCustomRule };
