import { GraphQLError as e } from "../../../error/GraphQLError.mjs";

import { getNamedType as r } from "../../../type/definition.mjs";

import { isIntrospectionType as o } from "../../../type/introspection.mjs";

function NoSchemaIntrospectionCustomRule(t) {
  return {
    Field: function Field(i) {
      var n = r(t.getType());
      if (n && o(n)) {
        t.reportError(new e('GraphQL introspection has been disabled, but the requested query contained the field "' + i.name.value + '".', i));
      }
    }
  };
}

export { NoSchemaIntrospectionCustomRule };
